package com.tin.tds;


/* 
 * FVU
 * ------------------------------------------------------------------------------------------------------------------------------------------

/* ------------------------------------------------------------------------------------------------------------------------------------------

 *  Modifications
 *  ------------- 
 *  M01      [M01_B  - Indicates beginning of the code change for M01  & M01_E - End of code change for M01]
 *  ----
 *  Description   : New value 80CCF is added in the list of allowable sections for form 24Q Q4  and section 16
 *  				If there, section should come in the order 80CCE,80CCF,OTHERS
 *  Modified By   : Dhanya P
 *  Modified Date : 09/12/2010
 *  
 *  ------------------------------------------------------------------------------------------------------------------------------------------
 *  
 *  M02     [M02_B  - Indicates beginning of the code change for M02  & M02_E - End of code change for M02] 
 *  ----
 *  Description    : Change in logic for validation in salary details for field Total Taxable Income with Surcharge and Education Cess
 *  				 The following new checks are added
 *  
 *  				 		File must be rejected if Surcharge on Total Income is greater than Total Taxable Income for electronic files.
 *							File must be rejected if Education Cess is greater than Total Taxable Income.
 *							File must be rejected if Surcharge on Total Income and Education Cess both are greater than Total Taxable Income.
 *							File must be rejected if (income tax on total income + surcharge + cess) > Total Taxable Income.
 *	
 *  Modified By    : Dhanya P
 *  Modififed Date : 14/12/2010
 *  
 *  ------------------------------------------------------------------------------------------------------------------------------------------
 *  
 *  ############################################################################################################
 *  Created on Oct 25, 2004
 *  Coding Complete till 28
    ############################################################################################################
 *  
 *  Note : Variables which are Name of Fields in the File format are starts with First Letter Capital
 *  Example : EmployeeName which is Name of Employe in the File Format.
 *  Local Variables starts with small letter.
 *  String Buffer are declared with Capital Letters. 
 *  
 *  
 *  
 */


//import java.awt.print.Paper;

import java.io.BufferedReader;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashSet;
import java.util.StringTokenizer;

import javax.swing.text.ParagraphView;

import com.tin.tds.util.FileGenerator;
import com.tin.tds.bean.FileStatistics;//AMI
import com.tin.FVU.*;

import java.math.BigDecimal;

public class SalaryDetailValidation implements FileValidatorInterface
{
	FormValidator fvO = null;

	public SalaryDetailValidation(FormValidator validator)
	{
		fvO = validator;
	}

	//   processing the deductee till the count is less then the countofdeductee  
	Calendar cal = new GregorianCalendar();

	//   public StringBuffer obj_StringBufferSal = new StringBuffer(500);
	//  StringBuffer DD_obj_StringBuffer = new StringBuffer();
	//  StringBuffer SC_obj_StringBuffer = new StringBuffer();

	FieldValidation obj_FieldValidation = new FieldValidation();

	String tab = "^";
	String LineNo = null;
	String RecType = null;

	boolean deducteeLevelError;
	boolean section16LevelError;
	boolean section10LevelError;
	boolean sectionVIALevelError;
	boolean section8889LevelError;
	boolean salaryDetailAddMode = false;
	
	
	boolean validSecVIATotAmount = true;   //Added by Dhanya on 03/02/2011 as 4047 msg has to be displayed only if all the amount in 16A are valid.  
	
	
	int prevSalaryDeducteeRecCount = 0;
	double SummationGrossTotIncome = 0;

	double sumOfTotalIncomeTaxDeductedAtSource = 0;
	double sumSection16 = 0;
	double sumSection10 = 0;
	double sumSectionVIA = 0;
	double sumSection8889 = 0;
	double sumTotalTDS = 0;
	String ModeSD = null;

	private StringBuffer statisticFileSDRec = new StringBuffer();
	private String statPANRepDelemiter = "&";
	private String statFileDataSeperator = "^";
//-----Added By Nahush
	public String CurrentDeducteeDetailRecNo = null ;
	public String CurrentlocalSDNumber = null;
	String lineNoOfSalaryDetailRec = "";
	/* To store Line Number of the Salary Detail Record whose Section Records we validate. 
												 * This line number is specified in Error File for the Errors occured in Control Total Fields of Section Record   
												 */

	// If the Value of all these count is Zero(0) then next Salary Detail Record is Read from the file if present.
	String countSec10 = null; // Getting the count of Section 10 after Salary Detail Validation 
	String countSec16 = null; // Getting the count of Section 16 after Salary Detail Validation
	String countSec6A = null; // Getting the count of Section 6A after Salary Detail Validation	
	String countSec88 = null; // Getting the count of Section 88 after Salary Detail Validation

	String[] sec16Array = new String[50]; // Array is used to store the Section 16 ID
	String[] sec10Array = new String[50]; // Array is used to store the Section 10 ID
	String[] secVIAArray = new String[50]; // Array is used to store the Section VI A ID
	String[] sec8889Array = new String[50]; // Array is used to store the Section 88 ID
	HashSet serialNoHS = new HashSet();

	//---- change in parameters done by Nahush
	public void salaryDetailValidator(
		String record,
		String UploadType,
		int LineCount,
		String RecTypeFM,
		String BH_BatchNo,
		BufferedReader br,
		String TransactionType,
		int countOfBatch,
		String Qperiod,
		String FormNo, //CHANGE AMI
	    String FinancialYr,
		String CountOfSalaryDetailRec,
		int i,
		String GrossTotalIncomeSD,
		Calendar RRRDatePresentDate,
		boolean paperReturnFile,
		String lineNoOfBatchRec,
		StringBuffer batchRecDataForPanStat,
		FileGenerator obj_FileGenerator,
		StringBufferTemp obj_StringBuffer,
		String fileNamePrintedinStatRep,
		String upload_Type,
		String PANForThisBatch,
		String BatchUpdationIndicator)
		throws Exception
	{

		boolean NullField = false;
		boolean error = false;
		boolean error_flag = false;
		boolean Caret = true;
		boolean FieldFound = false;
		boolean duplicateFileHeader = false;
		LineNo = Integer.toString(LineCount);
		String CH_BatchNo = "";
		String DD_BatchNo = null;
		String DeducteeDetailRecNo = null;
		int countOfLocalSalaryDeductee = Integer.parseInt(CountOfSalaryDetailRec.trim());
		salaryDetailAddMode = false;
		prevSalaryDeducteeRecCount = 0;
		sumOfTotalIncomeTaxDeductedAtSource = 0;
		deducteeLevelError = true;
		int DeducteeCount = 0;
		serialNoHS.clear();
		SummationGrossTotIncome = 0;
		RecType = RecTypeFM;

		try
		{

			for (int localDeducteeCount = 1; localDeducteeCount <= countOfLocalSalaryDeductee; localDeducteeCount++)
			{
				String FormNumber = null;
				String EmployeeSerialNo = null;
				String EmployeePan = null;
				String EmployeePanRefNo = null;
				String SalaryAsPerProvisionSec17 = null;
				String NumberPerqRecords = null;
				String ValueOfPerq17 = null;
				String ProfitSalSec17 = null;
				String GrossSalary = null;
				String CountDeducteeSec10 = null;
				String GrossTotalDeducteeSec10 = null;
				String TotalSal906 = null;
				String CountDeducteeSec16 = null;
				String GrossTotalDeducteeSec16 = null;
				String IncomeChargeableUderTheHeadSalaries = null;
				String IncomeIncludingLossFrmHouseProUderAnyHeadOtherThanIncomeUderTheHeadSalOfferedForTds = null;
				String GrossTotIncome = null;
				String LastGrossTotIncome = null;
				String CountDeducteeChapVIDetails = null;
				String GrossTotDeducteeChapVIDetails = null;
				String TotTaxableIncome213217 = null;
				String IncomeTaxOnTotIncome = null;
				String CountDeducteeSec8889 = null;
				String GrossTotDeducteeSec8889 = null;
				String NetTaxPayable = null;
				String TotIncomeTaxDeductedAtSource226227 = null;
				String TaxPayRef = null;

				sumSection10 = 0; // Initialise Section 10 Amount to 0 (ZERO)		
				sumSection16 = 0; // Initialise Section 16 Amount to 0 (ZERO)
				sumSection8889 = 0; // Initialise Section 88 Amount to 0 (ZERO)
				sumSectionVIA = 0; // Initialise Section VI-A Amount to 0 (ZERO)

				sec16Array = new String[50]; // Initialise Section 16 Array
				sec10Array = new String[50]; // Initialise Section 10 Array
				sec8889Array = new String[50]; // Initialise Section 88 Array
				secVIAArray = new String[50]; // Initialise Section VI-A Array

				String localSalaryDetailNo = "";
				/*
				 * If Record Type is not Salary Detail(SD) then we read the next line form the file.
				 */
				if (!(RecType.equals(SALARY_STATEMENT_IDENTIFIER)))
				{
					record = br.readLine();
					LineCount++;
					int localCountField_DD = 1;
					int localCaretCount = 0;
					String localSDNumber = "-";

					if (record == null || record.length() == 0)
					{
						obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
						fvO.returnRecordType = RecType;
						fvO.returnLineCount = LineCount;
						fvO.returnRecord = record;
						return;
					}
					if (record != null || record.length() > 0)
					{
						StringTokenizer st_DD = new StringTokenizer(record, "^", true);
						while (st_DD.hasMoreTokens())
						{
							String val = st_DD.nextToken();
							NullField = false;
							FieldFound = false;
							if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
							{
								NullField = true;
								FieldFound = true;
							}
							if (val.equals(FIELD_SEPERATOR))
							{
								Caret = true;
								if (localCaretCount == 0 && localCountField_DD == 1)
								{
									//        localCountField_DD++;
									LineNo = "";
								}
								localCaretCount++;
							}
							else
							{
								Caret = false;
								FieldFound = true;
							}
							if (localCountField_DD > 4)
							{
								break;
							}
							if (FieldFound)
							{
								switch (localCountField_DD)
								{
									case 1 :
										LineNo = val;
										break;
									case 2 :
										RecType = val;
										break;
									case 4 :
										localSDNumber = val;
										localSalaryDetailNo = val;
										break;

								} //Closing switch
								localCountField_DD++;
							} //Closing if
						}
					}
		
					if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_BATCH) || TransactionType.equals(TRANSACTIONTYPE_CANCELLATION_BATCH))

						CurrentlocalSDNumber = "Null";

						else

						CurrentlocalSDNumber = localSDNumber;
					
					
					if (localCaretCount != 4)
					{
						obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
						continue;
					}
					//			checking for non availablity of the Deductee
					if ((record == null || record.length() == 0) && localDeducteeCount <= countOfLocalSalaryDeductee)
					{
						obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
						fvO.returnRecordType = RecType;
						fvO.returnLineCount = LineCount;
						fvO.returnRecord = record;
						return;
					}
					if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && !RecType.equals(SALARY_STATEMENT_IDENTIFIER))
					{
						obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4124_C + tab + T_FV_4124_M);
						continue;
					}
				} // if (!(RecType.equals(SALARY_STATEMENT_IDENTIFIER) ))

				if (RecType.equals(SALARY_STATEMENT_IDENTIFIER))
				{
					if (record == null || record.length() == 0)
					{
						if (!(localDeducteeCount <= countOfLocalSalaryDeductee))
						{
							obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
						}
						fvO.returnRecordType = RecType;
						fvO.returnLineCount = LineCount;
						fvO.returnRecord = record;
						return;
					}

					DeducteeCount++;
					cal = new GregorianCalendar();

					if (localDeducteeCount == countOfLocalSalaryDeductee)
					{
						fvO.lastSalaryDeducteeError1 = obj_StringBuffer.errorBufferString.length();
					}

					long salDetailErrRecLengthBefore = obj_StringBuffer.errorBufferString.length();
					validateSalaryDeducteeDetails(
						record,
						LineCount,
						BH_BatchNo,
						DeducteeCount,
						countOfLocalSalaryDeductee,
						TransactionType,
						UploadType,
						Qperiod,
						FormNo, //CHANGE AMI
						FinancialYr,
						GrossTotalIncomeSD,
						RRRDatePresentDate,
						paperReturnFile,
						lineNoOfBatchRec,
						batchRecDataForPanStat,
						obj_FileGenerator,
						obj_StringBuffer,
						fileNamePrintedinStatRep,
						upload_Type,
						PANForThisBatch,
						BatchUpdationIndicator);

					cal = new GregorianCalendar();
					if (localDeducteeCount == countOfLocalSalaryDeductee)
					{

						fvO.lastSalaryDeducteeError2 = obj_StringBuffer.errorBufferString.length();

						if ((fvO.lastSalaryDeducteeError2 - fvO.lastSalaryDeducteeError1) == 0)
						{
							fvO.lastSalaryDeducteeFlag = true;
						}
						else
						{
							fvO.lastSalaryDeducteeFlag = false;
						}
					}

					long salDetailErrRecLengthAfter = obj_StringBuffer.errorBufferString.length();

					boolean errorInSalaryDetailRec = false;
					if ((salDetailErrRecLengthAfter - salDetailErrRecLengthBefore) != 0)
					{
						errorInSalaryDetailRec = true;
					}
					else
					{
						errorInSalaryDetailRec = false;
					}
					/*
					 *  This validation checks if the count of all Sections for one Salary Detail Record  				
					 *  If count of any Section is not equal to 0, sectionCountError flag is set to false else true
					 */
					boolean sectionCountError = false;
					try
					{
						if (/*Integer.parseInt(countSec10.trim()) == 0
																																																																																																																																																																																																																																																																																																																																																																																					&&*/
							Integer.parseInt(countSec16.trim()) == 0 && Integer.parseInt(countSec6A.trim()) == 0 /*&& Integer.parseInt(countSec88.trim()) == 0*/
							)
						{
							sectionCountError = true;
						}
						else
							sectionCountError = false;
					}
					catch (Exception e)
					{
						sectionCountError = false;
					}
					// This validation checks if the count of all Sections for one Salary Detail Record 				  

					if (errorInSalaryDetailRec
						|| TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN)
						|| (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D"))
						|| (sectionCountError == true))
					{
						error = true;
						deducteeLevelError = false;

						if ((localDeducteeCount != countOfLocalSalaryDeductee) || (i != countOfBatch))
						{
							String LocalMode = null;
							do
							{
								record = br.readLine();
								LineCount++;
								if (record == null || record.length() == 0)
								{
									if ((localDeducteeCount != countOfLocalSalaryDeductee))
									{
										obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
									}
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									return;
								}

								int localCaretCount = 0;
								int localCountField_DD = 1;
								String localSDNumber = "-";
								StringTokenizer st_DD = new StringTokenizer(record, "^", true);

								LineNo = null;
								RecType = null;

								while (st_DD.hasMoreTokens())
								{
									String val = st_DD.nextToken();
									NullField = false;
									FieldFound = false;
									if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
									{
										NullField = true;
										FieldFound = true;
									}
									if (val.equals(FIELD_SEPERATOR))
									{
										Caret = true;
										if (localCaretCount == 0 && localCountField_DD == 1)
										{
											//          localCountField_DD++;
											LineNo = "";
										}
										localCaretCount++;
									}
									else
									{
										Caret = false;
										FieldFound = true;
									}

									if (localCountField_DD > 5)
									{
										break;
									}
									if (FieldFound)
									{
										switch (localCountField_DD)
										{
											case 1 :
												LineNo = val;
												break;
											case 2 :
												RecType = val;
												break;
											case 4 :
												localSDNumber = val;
												break;
											case 5 :
												LocalMode = val;

										} //Closing switch
										localCountField_DD++;
									} //Closing if
								}


								if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_BATCH) || TransactionType.equals(TRANSACTIONTYPE_CANCELLATION_BATCH))

									CurrentlocalSDNumber = "Null";

									else

									CurrentlocalSDNumber = localSDNumber;
								
								
								
								
								
								if (localCaretCount != 2 && ((LineNo == null || LineNo.length() == 0) || (RecType == null || RecType.length() == 0)))
								{
									if (LineNo == null || LineNo.length() == 0)
										obj_StringBuffer.append("-" + tab + upload_Type + tab + "Line No" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4004_C + tab + T_FV_4004_M);
									else if ((RecType == null || RecType.length() == 0))
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4124_C + tab + T_FV_4124_M);
									else
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
									continue;
								}
								if (localCaretCount < 5)
								{
									obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
									continue;
								}
								if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN) && !RecType.equals(SALARY_STATEMENT_IDENTIFIER))
								{
									if ((localDeducteeCount == countOfLocalSalaryDeductee) && RecType.equals(BATCH_HEADER_IDENTIFIER))
									{
										/*
										 *  In case of Multiple Batch Correction, after Validation of all the Salary Detail Record
										 *  if a Batch Record is fountd we donot log error. Else we log error 
										 */
									}
									else
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4106_C + tab + T_FV_4106_M);
										continue;
									}
								}
								if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("D") && !RecType.equals(SALARY_STATEMENT_IDENTIFIER))
								{
									if ((localDeducteeCount == countOfLocalSalaryDeductee) && RecType.equals(BATCH_HEADER_IDENTIFIER))
									{
										/*
										 *  In case of Multiple Batch Correction, after Validation of all the Salary Detail Record
										 *  if a Batch Record is fountd we donot log error. Else we log error 
										 */
									}
									else
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_2139_C + tab + T_FV_2139_M);
										continue;
									}
								}
								else if ((localDeducteeCount == countOfLocalSalaryDeductee) && RecType.equals(SALARY_STATEMENT_IDENTIFIER))
								{
									obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
								}
								else if (sectionCountError && !RecType.equals(SALARY_STATEMENT_IDENTIFIER) && !RecType.equals(BATCH_HEADER_IDENTIFIER))
								{
									obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4124_C + tab + T_FV_4124_M);
								}
								else if ((localDeducteeCount != countOfLocalSalaryDeductee) && RecType.equals(BATCH_HEADER_IDENTIFIER))
								{
									obj_StringBuffer.append(lineNoOfBatchRec + tab + upload_Type + tab + "NA" + tab + tab + tab + T_FV_2129_C + tab + T_FV_2129_M);
								}

							}
							while (!(RecType.equals(BATCH_HEADER_IDENTIFIER) || RecType.equals(SALARY_STATEMENT_IDENTIFIER)));

							if (RecType.equals(BATCH_HEADER_IDENTIFIER))
							{
								fvO.returnRecordType = RecType;
								fvO.returnLineCount = LineCount;
								fvO.returnRecord = record;
								return;
							}
							if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_SALARY) && ModeSD.equals("A") && !RecType.equals(SALARY_STATEMENT_IDENTIFIER))
							{
								fvO.returnRecordType = RecType;
								fvO.returnLineCount = LineCount;
								fvO.returnRecord = record;
								return;
							}
							else if (RecType.equals(SALARY_STATEMENT_IDENTIFIER))
							{
								continue;
							}
						}
						else
						{
							continue;
						}
					}
					else
					{
						error = false;
						deducteeLevelError = true;
						StringTokenizer st_DD = new StringTokenizer(record, "^", true);
						String[] deducteeFields = new String[110];
						int localX = 0;
						int fieldCounter = 0;
						while (st_DD.hasMoreTokens())
						{
							fieldCounter++;
							String data = st_DD.nextToken();

							if (data.equals("^") && fieldCounter == 1)
							{
								fieldCounter++;
								deducteeFields[fieldCounter] = "";
							}
							else if (!data.equals("^") && fieldCounter == 1)
							{
								deducteeFields[fieldCounter] = data;
							}
							else if (data.equals("^") && (fieldCounter % 2) == 1)
							{
								fieldCounter++;
								deducteeFields[fieldCounter] = "";
							}
							else if (!data.equals("^") && (fieldCounter % 2) == 1)
							{
								deducteeFields[fieldCounter] = data;
							}
						}

						LineNo = deducteeFields[1];
						RecType = deducteeFields[3];
						DD_BatchNo = deducteeFields[5];
						DeducteeDetailRecNo = deducteeFields[7];
						ModeSD = deducteeFields[9];
						EmployeeSerialNo = deducteeFields[11];
						EmployeePan = deducteeFields[13];
						EmployeePanRefNo = deducteeFields[15];
						ProfitSalSec17 = deducteeFields[27];
						CountDeducteeSec16 = deducteeFields[29];
						GrossTotalDeducteeSec16 = deducteeFields[31];
						GrossTotIncome = deducteeFields[37];
						LastGrossTotIncome = deducteeFields[39];
						CountDeducteeChapVIDetails = deducteeFields[41];
						GrossTotDeducteeChapVIDetails = deducteeFields[43];
						IncomeTaxOnTotIncome = deducteeFields[47];
						NetTaxPayable = deducteeFields[55];

						
						if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_BATCH) || TransactionType.equals(TRANSACTIONTYPE_CANCELLATION_BATCH))
						{
							CurrentDeducteeDetailRecNo = "Null";
						}

						else
						{
							CurrentDeducteeDetailRecNo = DeducteeDetailRecNo;
						}


					
					}

				} // if((RecType.equals(QUATAR_DEDUCTEE_HEADER_IDENTIFIER)))
				else
				{
					deducteeLevelError = false;
					obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + localSalaryDetailNo + tab + T_FV_4124_C + tab + T_FV_4124_M);

					/*
					 * If Batch Record is identified We return to the FormValidator.java Class
					 */
					if (RecType.equals(BATCH_HEADER_IDENTIFIER))
					{
						fvO.returnRecordType = RecType;
						fvO.returnLineCount = LineCount;
						fvO.returnRecord = record;
						return;
					}

					do
					{

						record = br.readLine();
						LineCount++;
						if (record == null || record.length() == 0)
						{
							if (!(localDeducteeCount <= countOfLocalSalaryDeductee))
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + localDeducteeCount + tab + T_FV_4124_C + tab + T_FV_4124_M);
							}
							fvO.returnRecordType = RecType;
							fvO.returnLineCount = LineCount;
							fvO.returnRecord = record;
							return;
						}

						int localCountField_DD = 1;
						int localCaretCount = 0;
						String localSDNumber = "-";
						LineNo = null;
						RecType = null;

						StringTokenizer st_DD = new StringTokenizer(record, "^", true);
						while (st_DD.hasMoreTokens())
						{
							String val = st_DD.nextToken();
							NullField = false;
							FieldFound = false;
							if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
							{
								NullField = true;
								FieldFound = true;
							}
							if (val.equals(FIELD_SEPERATOR))
							{
								Caret = true;
								if (localCaretCount == 0 && localCountField_DD == 0)
								{
									localCountField_DD++;
									LineNo = "";
								}
								localCaretCount++;
							}
							else
							{
								Caret = false;
								FieldFound = true;
							}

							if (localCountField_DD > 4)
							{
								break;
							}
							if (FieldFound)
							{
								switch (localCountField_DD)
								{
									case 1 :
										LineNo = val;
										break;
									case 2 :
										RecType = val;
										break;
									case 4 :
										localSDNumber = val;
										break;
								} //Closing switch
								localCountField_DD++;
							} //Closing if
						}


						if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_BATCH) || TransactionType.equals(TRANSACTIONTYPE_CANCELLATION_BATCH))

							CurrentlocalSDNumber = "Null";

							else

							CurrentlocalSDNumber = localSDNumber;
						
						
						
						
						
						if (localCaretCount != 4 && ((LineNo == null || LineNo.length() == 0) || (RecType == null || RecType.length() == 0)))
						{
							obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
							continue;
						}

						if (localCaretCount < 4)
						{
							obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
							continue;
						}
					}
					while (!(RecType.equals(BATCH_HEADER_IDENTIFIER) || RecType.equals(SALARY_STATEMENT_IDENTIFIER)));

					if (RecType.equals(BATCH_HEADER_IDENTIFIER))
					{
						fvO.returnRecordType = RecType;
						fvO.returnLineCount = LineCount;
						fvO.returnRecord = record;
						return;
					}
					else if (RecType.equals(SALARY_STATEMENT_IDENTIFIER))
					{
						continue;
					}

				}

				//    Checking Section 16 records
				int section16ValidCount = 0;
				section16LevelError = true;

				int errorCountCode = obj_FieldValidation.checkNumeric(CountDeducteeSec16, 9);

				if (errorCountCode == 4)
				{
					if (deducteeLevelError && Integer.parseInt(CountDeducteeSec16.trim()) > 0)
					{
						for (int localCountSec16 = 0; localCountSec16 < Integer.parseInt(CountDeducteeSec16.trim()); localCountSec16++)
						{
				
							if (!(RecType.equals(SECTION16_HEADER_IDENTIFIER)))
							{
								record = br.readLine();
								LineCount++;

								if (record == null || record.length() == 0)
								{
									if (localCountSec16 < Integer.parseInt(CountDeducteeSec16.trim()))
									{
										obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Section 16 Detail ' Records  associated with this Deductee" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6030_C + tab + T_FV_6030_M);
									}
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;
								}
								if (record != null || record.length() > 0)
								{
									int localCountField_DD = 1;
									int localCaretCount = 0;

									StringTokenizer st_DD = new StringTokenizer(record, "^", true);
									while (st_DD.hasMoreTokens())
									{
										String val = st_DD.nextToken();
										NullField = false;
										FieldFound = false;
										if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
										{
											NullField = true;
											FieldFound = true;
										}
										if (val.equals(FIELD_SEPERATOR))
										{
											Caret = true;
											if (localCaretCount == 0 && localCountField_DD == 1)
											{
												//         localCountField_DD++;
												LineNo = "";
											}
											localCaretCount++;
										}
										else
										{
											Caret = false;
											FieldFound = true;
										}

										if (localCountField_DD > 3)
										{
											break;
										}

										if (FieldFound)
										{
											switch (localCountField_DD)
											{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;
											} //Closing switch
											localCountField_DD++;
										} //Closing if
									} //Closing While	

									if (localCaretCount < 3)
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6001_C + tab + T_FV_6001_M);
										continue;
									}
								}
								//			checking for non availablity of the Deductee
								if ((record == null || record.length() == 0) && (localCountSec16 + 1) <= Integer.parseInt(CountDeducteeSec16.trim()))
								{
									obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Section 16 Detail ' Records  associated with this Deductee " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6030_C + tab + T_FV_6030_M);
									section16LevelError = false;
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;
									//	   return obj_StringBufferSal ;
								}
							}

							if (RecType.equals(SECTION16_HEADER_IDENTIFIER))
							{
								section16ValidCount++;
								cal = new GregorianCalendar();
								long sec16ErrRecLengthBefore = obj_StringBuffer.errorBufferString.length();

								
								validateSection16(
									record,
									LineCount,
									BH_BatchNo,
									DeducteeDetailRecNo,
									CountDeducteeSec16,
									GrossTotalDeducteeSec16,
									section16ValidCount,
									paperReturnFile,
									obj_StringBuffer,
									upload_Type);

								cal = new GregorianCalendar();
								long sec16ErrRecLengthAfter = obj_StringBuffer.errorBufferString.length();

								boolean errorInSec16Record = false;
								if ((sec16ErrRecLengthAfter - sec16ErrRecLengthBefore) != 0)
								{
									errorInSec16Record = true;
								}
								else
								{
									errorInSec16Record = false;
								}
								if (!errorInSec16Record)
								{
									error = false;
									section16LevelError = true;

									if (section16ValidCount < Integer.parseInt(CountDeducteeSec16.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Section 16 Detail ' Records  associated with this Deductee " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6030_C + tab + T_FV_6030_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;
											//	 return obj_StringBufferSal;
										}

										int localCaretCount = 0;
										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
											{
												Caret = true;
												localCaretCount++;
											}
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
													case 1 :
														LineNo = val;
														break;
													case 2 :
														RecType = val;
														break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (localCaretCount < 2)
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6001_C + tab + T_FV_6001_M);
											continue;
										}

										if (RecType.equals(SECTION16_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
								else
								{
									error = true;
									section16LevelError = false;

									if (section16ValidCount < Integer.parseInt(CountDeducteeSec16.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCaretCount = 0;
										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
											{
												Caret = true;
												localCaretCount++;
											}
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
													case 1 :
														LineNo = val;
														break;
													case 2 :
														RecType = val;
														break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (localCaretCount < 2)
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6001_C + tab + T_FV_6001_M);
											continue;
										}
										if (RecType.equals(SECTION16_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
							} // if((RecType.equals(QUATAR_DEDUCTEE_HEADER_IDENTIFIER)))
							else
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
								section16LevelError = false;

								if (RecType.equals(BATCH_HEADER_IDENTIFIER))
								{
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									return;
								}

								if (section16ValidCount < Integer.parseInt(CountDeducteeSec16.trim()))
								{
									record = br.readLine();
									LineCount++;

									if (record == null || record.length() == 0)
									{
										fvO.returnRecordType = RecType;
										fvO.returnLineCount = LineCount;
										fvO.returnRecord = record;
										break;

									}

									int localCaretCount = 0;
									int localCountField_DD = 1;
									StringTokenizer st_DD = new StringTokenizer(record, "^", true);
									while (st_DD.hasMoreTokens())
									{
										String val = st_DD.nextToken();
										NullField = false;
										FieldFound = false;
										if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
										{
											NullField = true;
											FieldFound = true;
										}
										if (val.equals(FIELD_SEPERATOR))
										{
											Caret = true;
											localCaretCount++;
										}
										else
										{
											Caret = false;
											FieldFound = true;
										}

										if (localCountField_DD > 2)
										{
											break;
										}
										if (FieldFound)
										{
											switch (localCountField_DD)
											{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;

											} //Closing switch
											localCountField_DD++;
										} //Closing if
									} //Closing While	

									if (localCaretCount < 2)
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Section 10" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6002_C + tab + T_FV_6002_M);
										continue;
									}
									if (RecType.equals(SECTION16_HEADER_IDENTIFIER))
									{
										continue;
									}
									else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
										fvO.returnRecordType = RecType;
										fvO.returnLineCount = LineCount;
										fvO.returnRecord = record;
										return;
									}
									else
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
										break;
									}
								}
							}
						} // Closing for loop Section 16 record)
					} // Closing if(!deducteeLevelError && Integer.parseInt(CountDeducteeSec16)>0 && section16LevelError)
				}

				//	 Checking Section 10 records

				int Sec10ValidCount = 0;
				section10LevelError = true;

				errorCountCode = obj_FieldValidation.checkNumeric(CountDeducteeSec10, 9);

				if (errorCountCode == 4)
				{
					if (deducteeLevelError && Integer.parseInt(CountDeducteeSec10.trim()) > 0) //&& section16LevelError && section10LevelError)
					{
						for (int localCountSec10 = 0; localCountSec10 < Integer.parseInt(CountDeducteeSec10.trim()); localCountSec10++)
						{
							if (!(RecType.equals(SECTION10_HEADER_IDENTIFIER)))
							{
								record = br.readLine();
								LineCount++;

								if (record == null || record.length() == 0)
								{
									if (localCountSec10 < Integer.parseInt(CountDeducteeSec10.trim()))
									{
										obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section-10" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6031_C + tab + T_FV_6031_M);
									}
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;
								}

								if (record != null || record.length() > 0)
								{
									int localCaretCount = 0;
									int localCountField_DD = 1;
									StringTokenizer st_DD = new StringTokenizer(record, "^", true);
									while (st_DD.hasMoreTokens())
									{
										String val = st_DD.nextToken();
										NullField = false;
										FieldFound = false;
										if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
										{
											NullField = true;
											FieldFound = true;
										}
										if (val.equals(FIELD_SEPERATOR))
										{
											Caret = true;
											localCaretCount++;
										}
										else
										{
											Caret = false;
											FieldFound = true;
										}

										if (localCountField_DD > 2)
										{
											break;
										}
										if (FieldFound)
										{
											switch (localCountField_DD)
											{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;

											} //Closing switch
											localCountField_DD++;
										} //Closing if
									} //Closing While	
									if (localCaretCount < 2)
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Section-10" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6002_C + tab + T_FV_6002_M);
										continue;
									}
								}

								if ((record == null || record.length() == 0) && (localCountSec10 + 1) <= Integer.parseInt(CountDeducteeSec10.trim()))
								{
									obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section-10" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6031_C + tab + T_FV_6031_M);
									section10LevelError = false;
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;
									//			  return obj_StringBufferSal ;
								}
							}

							if (RecType.equals(SECTION10_HEADER_IDENTIFIER))
							{
								Sec10ValidCount++;
								long sec10ErrRecLengthBefore = obj_StringBuffer.errorBufferString.length();
								cal = new GregorianCalendar();
								
								//								validateSection10(record, LineCount, BH_BatchNo, DeducteeDetailRecNo, CountDeducteeSec10, GrossTotalDeducteeSec10, Sec10ValidCount, paperReturnFile, obj_StringBuffer);

								cal = new GregorianCalendar();
								
								long sec10ErrRecLengthAfter = obj_StringBuffer.errorBufferString.length();

								boolean errorInSec10Record = false;
								if ((sec10ErrRecLengthBefore - sec10ErrRecLengthAfter) != 0)
								{
									errorInSec10Record = true;
								}
								else
								{
									errorInSec10Record = false;
								}

								if (!errorInSec10Record)
								{
									error = false;
									section10LevelError = true;

									if (Sec10ValidCount < Integer.parseInt(CountDeducteeSec10.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section-10" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6031_C + tab + T_FV_6031_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
												Caret = true;
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
													case 1 :
														LineNo = val;
														break;
													case 2 :
														RecType = val;
														break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (RecType.equals(SECTION10_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Recor Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Recor Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
								else
								{
									error = true;
									section10LevelError = false;

									if (Sec10ValidCount < Integer.parseInt(CountDeducteeSec10.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
												Caret = true;
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
													case 1 :
														LineNo = val;
														break;
													case 2 :
														RecType = val;
														break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (RecType.equals(SECTION10_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Recor Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Recor Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
							} // if((RecType.equals(QUATAR_DEDUCTEE_HEADER_IDENTIFIER)))
							else if (RecType.equals(SECTION16_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Section 16 Detail ' Records  associated with this Deductee " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6030_C + tab + T_FV_6030_M);
								section10LevelError = false;
								localCountSec10 = localCountSec10 - 1;
							}
							else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
								fvO.returnRecordType = RecType;
								fvO.returnLineCount = LineCount;
								fvO.returnRecord = record;
								return;
							}
							else
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
								section10LevelError = false;
								break;
							}
						} // Closing for loop Section 16 record)
					}
				}

				// Closing if(!deducteeLevelError && Integer.parseInt(CountDeducteeSec16)>0 && section16LevelError)	
				//		Checking Section Chapter VI-A records

				int SecVIAValidCount = 0;
				sectionVIALevelError = true;

				errorCountCode = obj_FieldValidation.checkNumeric(CountDeducteeChapVIDetails, 9);

				if (errorCountCode == 4)
				{
					if (deducteeLevelError && Integer.parseInt(CountDeducteeChapVIDetails.trim()) > 0) // && section16LevelError && section10LevelError)
					{
						for (int localCountSecVIA = 0; localCountSecVIA < Integer.parseInt(CountDeducteeChapVIDetails.trim()); localCountSecVIA++)
						{
							if (!(RecType.equals(SECTIONVIA_HEADER_IDENTIFIER)))
							{
								record = br.readLine();
								LineCount++;

								if (record == null || record.length() == 0)
								{
									if (localCountSecVIA < Integer.parseInt(CountDeducteeChapVIDetails.trim()))
									{
										obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6033_C + tab + T_FV_6033_M);
									}
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;

								}

								if (record != null || record.length() > 0)
								{
									int localCountField_DD = 1;
									StringTokenizer st_DD = new StringTokenizer(record, "^", true);
									while (st_DD.hasMoreTokens())
									{
										String val = st_DD.nextToken();
										NullField = false;
										FieldFound = false;
										if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
										{
											NullField = true;
											FieldFound = true;
										}
										if (val.equals(FIELD_SEPERATOR))
											Caret = true;
										else
										{
											Caret = false;
											FieldFound = true;
										}

										if (localCountField_DD > 2)
										{
											break;
										}
										if (FieldFound)
										{
											switch (localCountField_DD)
											{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;

											} //Closing switch
											localCountField_DD++;
										} //Closing if
									} //Closing While	
								}

								if ((record == null || record.length() == 0) && (localCountSecVIA + 1) <= Integer.parseInt(CountDeducteeChapVIDetails.trim()))
								{
									obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6033_C + tab + T_FV_6033_M);
									section10LevelError = false;
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;

								}
							}

							if ((RecType.equals(SECTIONVIA_HEADER_IDENTIFIER) || RecType == null))
							{
								SecVIAValidCount++;
								long secVIErrRecLengthBefore = obj_StringBuffer.errorBufferString.length();
								cal = new GregorianCalendar();
								
								validateSectionVIA(
									record,
									LineCount,
									BH_BatchNo,
									DeducteeDetailRecNo,
									CountDeducteeChapVIDetails,
									GrossTotDeducteeChapVIDetails,
									SecVIAValidCount,
									paperReturnFile,
									obj_StringBuffer,
									upload_Type );

								cal = new GregorianCalendar();
								
								long secVIErrRecLengthAfter = obj_StringBuffer.errorBufferString.length();
								boolean errorInSecVIRecord = false;
								if ((secVIErrRecLengthAfter - secVIErrRecLengthBefore) != 0)
								{
									errorInSecVIRecord = true;
								}
								else
								{
									errorInSecVIRecord = false;
								}

								if (!errorInSecVIRecord)
								{
									error = false;
									sectionVIALevelError = true;

									if (SecVIAValidCount < Integer.parseInt(CountDeducteeChapVIDetails.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6033_C + tab + T_FV_6033_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
												Caret = true;
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
													case 1 :
														LineNo = val;
														break;
													case 2 :
														RecType = val;
														break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (RecType.equals(SECTIONVIA_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
								else
								{
									error = true;
									sectionVIALevelError = false;

									if (SecVIAValidCount < Integer.parseInt(CountDeducteeChapVIDetails.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + tab + CurrentlocalSDNumber + tab + T_FV_6033_C + tab + T_FV_6033_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
												Caret = true;
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
													case 1 :
														LineNo = val;
														break;
													case 2 :
														RecType = val;
														break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	

										if (RecType.equals(SECTIONVIA_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);

											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
							} //  if ((RecType.equals(SECTIONVIA_HEADER_IDENTIFIER) || RecType == null))
							else if (RecType.equals(SECTION10_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section Record" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6031_C + tab + T_FV_6031_M);
								sectionVIALevelError = false;
								localCountSecVIA = localCountSecVIA - 1;
							}
							else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);

								fvO.returnRecordType = RecType;
								fvO.returnLineCount = LineCount;
								fvO.returnRecord = record;
								return;
							}
							else
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
								sectionVIALevelError = false;
								break;
							}
						} // Closing for loop Section 16 record)
					}
				} // Closing if(deducteeLevelError && Integer.parseInt(CountDeducteeSec16)>0 && section16LevelError)

				//		Checking Section 8889 records

				int Sec8889ValidCount = 0;
				section8889LevelError = true;

				errorCountCode = obj_FieldValidation.checkNumeric(CountDeducteeSec8889, 9);

				if (errorCountCode == 4)
				{
					if (deducteeLevelError && Integer.parseInt(CountDeducteeSec8889.trim()) > 0) //&& section16LevelError && section10LevelError)
					{
						for (int localCountSec8889 = 0; localCountSec8889 < Integer.parseInt(CountDeducteeSec8889.trim()); localCountSec8889++)
						{
							if (!(RecType.equals(SECTION8889_HEADER_IDENTIFIER)))
							{
								record = br.readLine();
								LineCount++;

								if (record == null || record.length() == 0)
								{
									if (localCountSec8889 < Integer.parseInt(CountDeducteeSec8889.trim()))
									{
										obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section-88" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6032_C + tab + T_FV_6032_M);
									}
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;

								}

								if (record != null || record.length() > 0)
								{
									int localCaretCount89 = 0;
									int localCountField_DD = 1;
									StringTokenizer st_DD = new StringTokenizer(record, "^", true);
									while (st_DD.hasMoreTokens())
									{
										String val = st_DD.nextToken();
										NullField = false;
										FieldFound = false;
										if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
										{
											NullField = true;
											FieldFound = true;
										}
										if (val.equals(FIELD_SEPERATOR))
										{
											Caret = true;
											localCaretCount89++;
										}
										else
										{
											Caret = false;
											FieldFound = true;
										}

										if (localCountField_DD > 2)
										{
											break;
										}
										if (FieldFound)
										{
											switch (localCountField_DD)
											{
												case 1 :
													LineNo = val;
													break;
												case 2 :
													RecType = val;
													break;

											} //Closing switch
											localCountField_DD++;
										} //Closing if
									} //Closing While	

									if (localCaretCount89 < 2)
									{
										obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6004_C + tab + T_FV_6004_M);
										continue;
									}
								}

								if ((record == null || record.length() == 0) && (localCountSec8889 + 1) <= Integer.parseInt(CountDeducteeSec8889.trim()))
								{
									obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6032_C + tab + T_FV_6032_M);
									section10LevelError = false;
									fvO.returnRecordType = RecType;
									fvO.returnLineCount = LineCount;
									fvO.returnRecord = record;
									break;

								}
							}

							if ((RecType.equals(SECTION8889_HEADER_IDENTIFIER) || RecType == null))
							{
								Sec8889ValidCount++;

								cal = new GregorianCalendar();
								long sec8889ErrRecLengthBefore = obj_StringBuffer.errorBufferString.length();
								
								/*								validateSection8889(
																	record,
																	LineCount,
																	BH_BatchNo,
																	DeducteeDetailRecNo,
																	CountDeducteeSec8889,
																	GrossTotDeducteeSec8889,
																	Sec8889ValidCount,
																	paperReturnFile,
																	obj_StringBuffer);
								*/
								cal = new GregorianCalendar();
								
								long sec8889ErrRecLengthAfter = obj_StringBuffer.errorBufferString.length();
								boolean errorInSec8889RecLength = false;

								if ((sec8889ErrRecLengthAfter - sec8889ErrRecLengthBefore) != 0)
								{
									errorInSec8889RecLength = true;
								}
								else
								{
									errorInSec8889RecLength = false;
								}

								if (!errorInSec8889RecLength)
								{
									error = false;
									section8889LevelError = true;

									if (Sec8889ValidCount < Integer.parseInt(CountDeducteeSec8889.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Section-88" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6032_C + tab + T_FV_6032_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCountField_DD = 1;
										int localCaretCounter88 = 0;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
											{
												Caret = true;
												localCaretCounter88++;
											}
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
													case 1 :
														LineNo = val;
														break;
													case 2 :
														RecType = val;
														break;

												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While

										if (localCaretCounter88 < 2)
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6004_C + tab + T_FV_6004_M);
											continue;
										}

										if (RecType.equals(SECTION8889_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);

											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}
								else
								{
									error = true;
									section8889LevelError = false;

									if (Sec8889ValidCount < Integer.parseInt(CountDeducteeSec8889.trim()))
									{
										record = br.readLine();
										LineCount++;

										if (record == null || record.length() == 0)
										{
											obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6032_C + tab + T_FV_6032_M);
											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											break;

										}

										int localCaretCounter88 = 0;
										int localCountField_DD = 1;
										StringTokenizer st_DD = new StringTokenizer(record, "^", true);
										while (st_DD.hasMoreTokens())
										{
											String val = st_DD.nextToken();
											NullField = false;
											FieldFound = false;
											if ((val.equals(FIELD_SEPERATOR) && Caret) || val.length() == 0)
											{
												NullField = true;
												FieldFound = true;
											}
											if (val.equals(FIELD_SEPERATOR))
											{
												Caret = true;
												localCaretCounter88++;
											}
											else
											{
												Caret = false;
												FieldFound = true;
											}

											if (localCountField_DD > 2)
											{
												break;
											}
											if (FieldFound)
											{
												switch (localCountField_DD)
												{
													case 1 :
														LineNo = val;
														break;
													case 2 :
														RecType = val;
														break;
												} //Closing switch
												localCountField_DD++;
											} //Closing if
										} //Closing While	
										if (localCaretCounter88 < 2)
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6004_C + tab + T_FV_6004_M);
											continue;
										}
										if (RecType.equals(SECTION8889_HEADER_IDENTIFIER))
										{
											continue;
										}
										else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);

											fvO.returnRecordType = RecType;
											fvO.returnLineCount = LineCount;
											fvO.returnRecord = record;
											return;
										}
										else
										{
											obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
											break;
										}
									}
								}

							} // if((RecType.equals(QUATAR_DEDUCTEE_HEADER_IDENTIFIER)))
							else if (RecType.equals(SECTIONVIA_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(lineNoOfSalaryDetailRec + tab + upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6033_C + tab + T_FV_6033_M);
								sectionVIALevelError = false;
								localCountSec8889 = localCountSec8889 - 1;
							}
							else if (RecType.equals(BATCH_HEADER_IDENTIFIER))
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);

								fvO.returnRecordType = RecType;
								fvO.returnLineCount = LineCount;
								fvO.returnRecord = record;
								return;
							}
							else
							{
								obj_StringBuffer.append(LineNo + tab + upload_Type + tab + "Salary Detail Record Type" + tab + tab + CurrentlocalSDNumber + tab + T_FV_6006_C + tab + T_FV_6006_M);
								section8889LevelError = true;
								break;
							}
						} // Closing for loop Section 8889 record)
					}
				} // Closing if(!deducteeLevelError && Integer.parseInt(CountDeducteeSec16)>0 && section16LevelError)
			} //CLOSING FOR for (int k = 1; k <= countOfDeducteeSD; k++)
		}
		catch (Exception e1)
		{			
			throw e1;
		} //CLOSING CATCH	

		fvO.returnRecordType = RecType;
		fvO.returnLineCount = LineCount;
		fvO.returnRecord = record;
		return;
	}

	////////////    Validate Salary Statement Record START ////////////////

	private void validateSalaryDeducteeDetails(
		String deductee,
		int LineCount,
		String BH_BatchNo,
		int DeducteeCount,
		int localCountOfSD,
		String TransactionType,
		String UploadType,
		String Qperiod,
		String FormNo, //CHANGE AMI
		String FinancialYr,
		String GrossTotalIncomeSD,
		Calendar RRRDatePresentDate,
		boolean paperReturnFile,
		String lineNoOfBatchRec,
		StringBuffer batchRecDataForPanStat,
		FileGenerator obj_FileGenerator,
		StringBufferTemp obj_StringBuffer,
		String fileNamePrintedinStatRep,
		String v_upload_Type,
		String PANForThisBatch,
		String BatchUpdationIndicator)
		throws Exception
	{

		StringBufferTemp Str_Buffer;
		Str_Buffer = obj_StringBuffer;
		boolean NullField = false;
		boolean localErrorFlag = false;
		
		//Added By AMI For FVU 3.0
		FormValidator formVal = new FormValidator();
		
		try
		{
			String LineNo = null;
			String RecType = null;
			String DD_BatchNo = null;
			String DeducteeDetailRecNo = null;
			String EmployeeSerialNo = null;
			String EmployeePan = null;
			String EmployeePanRefNo = null;
			String EmployeeName = null;
			String EmployeeCategory = null;
			String PeriodEmploymentFrm = null;
			String PeriodEmploymentTo = null;
			String ProfitSalSec17 = null;
			String CountDeducteeSec16 = null;
			String GrossTotalDeducteeSec16 = null;
			String IncomeChargeableUderTheHeadSalaries = null;
			String IncomeLossFrmHouse = null;
			String GrossTotIncome = null;
			String LastGrossTotIncome = null;
			String CountDeducteeChapVIDetails = null;
			String GrossTotDeducteeChapVIDetails = null;
			String TotTaxableIncome340344 = null;
			String IncomeTaxOnTotIncome = null;
			String Surcharge = null;
			String Cess = null;
			String NetTaxPayable = null;
			String TotTDSWholeYear = null;
			String ShortfallExcessTaxDeduc = null;
			String Remark1 = null;
			String Remark2 = null;
			String Remark3 = null;
			String TotalSalaryExeclud333n334 = null;
			String IncomeTaxRelief = null;
			String SalaryDeducteeHash = null;

			int Count_DD_field = 1;
			FieldValidation obj_FieldValidation = new FieldValidation();

			StringTokenizer st_DD = new StringTokenizer(deductee, "^", true);

			boolean fieldfound = false;
			boolean Caret = false;
			boolean FieldFound;

			int caretCounter = 0;
			String localSDNumber = "NA";

			Count_DD_field = 1;
			while (st_DD.hasMoreTokens())
			{
				String val = st_DD.nextToken();
				NullField = false;
				FieldFound = false;
				if ((val.equals(FIELD_SEPERATOR) && Caret) || val.trim().length() == 0)
				{
					NullField = true;
					FieldFound = true;
				}

				if (val.equals(FIELD_SEPERATOR))
				{
					Caret = true;
					if ((caretCounter == 0) && (Count_DD_field == 1))
					{
						Count_DD_field++;
						LineNo = "";
					}
					caretCounter++;
				}
				else
				{
					Caret = false;
					FieldFound = true;
				}

				if (Count_DD_field > 34)
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
					fvO.returnRecordType = RecType;
					return;
				}
				if (FieldFound)
				{
					switch (Count_DD_field)
					{
						case 1 :
							LineNo = val;
							break;
						case 2 :
							RecType = val;
							break;
						case 3 :
							DD_BatchNo = val;
							break;
						case 4 :
							DeducteeDetailRecNo = val;
							break;
						case 5 :
							ModeSD = val;
							break;
						case 6 :
							EmployeeSerialNo = val; // Filler-7 Field
							break;
						case 7 :
							EmployeePan = val;
							break;
						case 8 :
							EmployeePanRefNo = val;
							break;
						case 9 :
							EmployeeName = val;
							break;
						case 10 :
							EmployeeCategory = val;
							break;
						case 11 :
							PeriodEmploymentFrm = val;
							break;
						case 12 :
							PeriodEmploymentTo = val;
							break;
						case 13 :
							TotalSalaryExeclud333n334 = val;
							break;
						case 14 :
							ProfitSalSec17 = val;
							break;
						case 15 :
							CountDeducteeSec16 = val;
							countSec16 = val;
							break;
						case 16 :
							GrossTotalDeducteeSec16 = val;
							break;
						case 17 :
							IncomeChargeableUderTheHeadSalaries = val;
							break;
						case 18 :
							IncomeLossFrmHouse = val;
							break;
						case 19 :
							GrossTotIncome = val;
							break;
						case 20 :
							LastGrossTotIncome = val;
							break;
						case 21 :
							CountDeducteeChapVIDetails = val;
							countSec6A = val;
							break;
						case 22 :
							GrossTotDeducteeChapVIDetails = val;
							break;
						case 23 :
							TotTaxableIncome340344 = val;
							break;
						case 24 :
							IncomeTaxOnTotIncome = val;
							break;
						case 25 :
							Surcharge = val;
							break;
						case 26 :
							Cess = val;
							break;
						case 27 :
							IncomeTaxRelief = val;
							break;
						case 28 :
							NetTaxPayable = val;
							break;
						case 29 :
							TotTDSWholeYear = val;
							break;
						case 30 :
							ShortfallExcessTaxDeduc = val;
							break;
						case 31 :
							Remark1 = val;
							break;
						case 32 :
							Remark2 = val;
							break;
						case 33 :
							Remark3 = val;
							break;
						case 34 :
							SalaryDeducteeHash = val;
							break;

					} //SWITCH
					Count_DD_field++;
				}
			} //WHILE

			if (caretCounter != 33)
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + tab + CurrentlocalSDNumber + tab + T_FV_4064_C + tab + T_FV_4064_M);
				fvO.returnRecordType = RecType;
				return;
			}
			//check of deductee fields starts

			//	  check LineNo --1

			if (LineNo.equals(FIELD_NULL) || LineNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4004_C + tab + T_FV_4004_M);
				LineNo = "-";
			}
			else if (LineNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(LineNo))
				{
					Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4004_C + tab + T_FV_4004_M);
					LineNo = "-";
				}
				else if (Integer.parseInt(LineNo.trim()) != LineCount)
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4003_C + tab + T_FV_4003_M);
				else
					lineNoOfSalaryDetailRec = LineNo;
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "Line_Number" + tab + CurrentlocalSDNumber + tab + T_FV_4004_C + tab + T_FV_4004_M);
			//	  check LineNo --1

			//	  check RecType --2
			if (RecType.equals(FIELD_NULL) || RecType.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Detail Record Type" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4124_C + tab + T_FV_4124_M);
			}
			else if (!(RecType.equals(SALARY_STATEMENT_IDENTIFIER)))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Detail Record Type" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4124_C + tab + T_FV_4124_M);
			}

			//		check RecType --2
			//	  check BatchNo --3
			if (DD_BatchNo.equals(FIELD_NULL) || DD_BatchNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4005_C + tab + T_FV_4005_M);
			}
			else if (DD_BatchNo.length() > 9)
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4005_C + tab + T_FV_4005_M);
			}
			else if (obj_FieldValidation.isInt(DD_BatchNo))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4005_C + tab + T_FV_4005_M);
			}
			else if (Integer.parseInt(DD_BatchNo.trim()) != Integer.parseInt(BH_BatchNo.trim()))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4169_C + tab + T_FV_4169_M);
			}
			//				check BatchNo --3

			//		check DeducteeDetailRecNo --4
			boolean validDeducteeDetailRecNo = false;
			if (DeducteeDetailRecNo.equals(FIELD_NULL) || DeducteeDetailRecNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + "NULL" + tab + T_FV_4174_C + tab + T_FV_4174_M);
			        
			
			}
			else
			{
				if (DeducteeDetailRecNo.length() <= 9)
				{
					if (obj_FieldValidation.isInt(DeducteeDetailRecNo))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4174_C + tab + T_FV_4174_M);
					}
					else if (UploadType.equals(UPLOADTYPE_REGULAR))
					{
						if (Integer.parseInt(DeducteeDetailRecNo.trim()) != DeducteeCount)
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4174_C + tab + T_FV_4174_M);
						else
							validDeducteeDetailRecNo = true;
					}
					else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					{
						if (prevSalaryDeducteeRecCount >= Integer.parseInt(DeducteeDetailRecNo.trim()))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + T_FV_4168_C + tab + T_FV_4168_M);
						}
						validDeducteeDetailRecNo = true;
						prevSalaryDeducteeRecCount = Integer.parseInt(DeducteeDetailRecNo.trim());
					}
					else
					{
						if ((salaryDetailAddMode == true) && ((prevSalaryDeducteeRecCount + 1) != Integer.parseInt(DeducteeDetailRecNo.trim())))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4174_C + tab + T_FV_4174_M);
						}
						else if ((salaryDetailAddMode == false) && (prevSalaryDeducteeRecCount >= Integer.parseInt(DeducteeDetailRecNo.trim())))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + tab + T_FV_4168_C + tab + T_FV_4168_M);
						}
						prevSalaryDeducteeRecCount = Integer.parseInt(DeducteeDetailRecNo.trim());
						validDeducteeDetailRecNo = true;
					}
				}
				else
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Salary Details  Record No" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4174_C + tab + T_FV_4174_M);
				}
			}
			//	  check DeducteeDetailRecNo --4

			//			Check ModeSD  ----  5
			if (ModeSD.equals(FIELD_NULL) || ModeSD.equals(FIELD_SEPERATOR))
			{
				if (!TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4120_C + tab + T_FV_4120_M);
				else
				{
					salaryDetailAddMode = true;
					prevSalaryDeducteeRecCount = Integer.parseInt(DeducteeDetailRecNo.trim());
				}
			}
			else
			{
				if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4131_C + tab + T_FV_4131_M);
				}
				else if (UploadType.equals(UPLOADTYPE_REGULAR))
				{
					if (!ModeSD.equals("A"))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4127_C + tab + T_FV_4127_M);
					else if (validDeducteeDetailRecNo)
						fvO.receiptLastSDNumber = Integer.toString(Integer.parseInt(DeducteeDetailRecNo.trim()));

				}
				else if (!ModeSD.equals("D") && !ModeSD.equals("A"))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4121_C + tab + T_FV_4121_M);
				}
				else if ((salaryDetailAddMode == true) && !ModeSD.equals("A"))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Mode" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4173_C + tab + T_FV_4173_M);
				}
				else if (ModeSD.equals("A"))
				{
					salaryDetailAddMode = true;

					if (!DeducteeDetailRecNo.trim().equals("^"))
					{
						prevSalaryDeducteeRecCount = Integer.parseInt(DeducteeDetailRecNo.trim());  //to be changed for 7.0
					}
					fvO.receiptLastSDNumber = Integer.toString(prevSalaryDeducteeRecCount);
				}
			}
			//			Check ModeSD --5

			//		check EmployeeSerialNo  ----6 
			if (!EmployeeSerialNo.equals(FIELD_NULL) && !EmployeeSerialNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Filler 7" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4008_C + tab + T_FV_4008_M);
			}
			//	  check EmployeeSerialNo ---6

			//	check EmployeePan   ----   7
			if (EmployeePan.equals(FIELD_NULL) || EmployeePan.equals(FIELD_SEPERATOR) || EmployeePan.trim().length() == 0)
			{
				if (paperReturnFile)
				{
					fvO.setPaperReturnRelax(true);
					//fvO.receiptPanInvaild++;
					fvO.receiptSalPanInvaild++;
					Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
					/*
					* code added on 06-oct-2006 to make an entry of Null value of PAN
					* in PAN stat buffer file.
					*/
					if (fvO.batchNumberOfRecord == 0)
					{
						fvO.batchNumberOfRecord = Integer.parseInt(BH_BatchNo.trim());
						Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatFileHeader());
						Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureStart(batchRecDataForPanStat.toString()));
						batchRecDataForPanStat = new StringBuffer();
						Str_Buffer.appendPANStat("<TR>");
						Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
						Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
						Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + "" + "</TD>");
						Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "PAN not Provided" + "</TD>");
						Str_Buffer.appendPANStat("</TR>");
					}
					else if (fvO.batchNumberOfRecord == Integer.parseInt(BH_BatchNo.trim()))
					{
						Str_Buffer.appendPANStat("<TR>");
						Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
						Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
						Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + "" + "</TD>");
						Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "PAN not Provided" + "</TD>");
						Str_Buffer.appendPANStat("</TR>");
					}
				}
				else if (ModeSD.equals("A") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
				}
			}
			else
			{
				if (ModeSD.equals("D"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4136_C + tab + T_FV_4136_M);
				else if (EmployeePan.length() > 10)
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
				else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN) && obj_FieldValidation.checkPan(EmployeePan))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
				else if (!EmployeePan.equals(PAN_NOT_AVAILABLE) && !EmployeePan.equals(PAN_APPLIED) && !EmployeePan.equals(PAN_INVALID))
				{
					if (EmployeePan.length() == 10 && EmployeePan.trim().length() == 10)
					{
						
						if (obj_FieldValidation.checkPan(EmployeePan))
						{
							if (paperReturnFile)
							{
								if (obj_FieldValidation.isAlphaNum(EmployeePan))
								{
									Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
								}
								else
								{
									fvO.setPaperReturnRelax(true);
									Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4009_C + tab + T_FV_4009_M);
									//fvO.receiptPanInvaild++;
									fvO.receiptSalPanInvaild++;
									/*
									* code added on 06-oct-2006 to make an entry of Structurally invalid PAN
									* in PAN stat buffer file.
									*/
									if (fvO.batchNumberOfRecord == 0)
									{
										fvO.batchNumberOfRecord = Integer.parseInt(BH_BatchNo.trim());
										Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatFileHeader());
										Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureStart(batchRecDataForPanStat.toString()));
										batchRecDataForPanStat = new StringBuffer();
										Str_Buffer.appendPANStat("<TR>");
										Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
										Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
										Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
										Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "Structurally Invalid Pan" + "</TD>");
										Str_Buffer.appendPANStat("</TR>");
									}
									else if (fvO.batchNumberOfRecord == Integer.parseInt(BH_BatchNo.trim()))
									{
										Str_Buffer.appendPANStat("<TR>");
										Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
										Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
										Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
										Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "Structurally Invalid Pan" + "</TD>");
										Str_Buffer.appendPANStat("</TR>");
									}
								}
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
						}
						//CHANGE AMI
						else if(FormNo.equals(FORM_24Q) && !paperReturnFile && Qperiod.equals("Q4") && (ModeSD.equals("A") || UploadType.equals(UPLOADTYPE_REGULAR) || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN)))
						{
							if(obj_FieldValidation.checkPanForthDigit24Q(EmployeePan))
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4264_C + tab + T_FV_4264_M);
							else
								fvO.receiptSalValidPAN++;
						}
						//END
							
						else
							//fvO.receiptValidPAN++;
						    fvO.receiptSalValidPAN++;
					}
					else
					{
						if (paperReturnFile)
						{
							if (obj_FieldValidation.isAlphaNum(EmployeePan))
							{
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
							}
							else
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4009_C + tab + T_FV_4009_M);
								//fvO.receiptPanInvaild++;
								fvO.receiptSalPanInvaild++;
								/*
								  * code added on 06-oct-2006 to make an entry of Structurally invalid PAN
								  * in PAN stat buffer file.
								*/
								if (fvO.batchNumberOfRecord == 0)
								{
									fvO.batchNumberOfRecord = Integer.parseInt(BH_BatchNo.trim());
									Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatFileHeader());
									Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureStart(batchRecDataForPanStat.toString()));
									batchRecDataForPanStat = new StringBuffer();
									Str_Buffer.appendPANStat("<TR>");
									Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
									Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
									Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
									Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "Structurally Invalid Pan" + "</TD>");
									Str_Buffer.appendPANStat("</TR>");
								}
								else if (fvO.batchNumberOfRecord == Integer.parseInt(BH_BatchNo.trim()))
								{
									Str_Buffer.appendPANStat("<TR>");
									Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
									Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
									Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
									Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + "Structurally Invalid Pan" + "</TD>");
									Str_Buffer.appendPANStat("</TR>");
								}
							}
						}
						else
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Employee PAN" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4009_C + tab + T_FV_4009_M);
					}
				}
				else
				{
					// used to generate provisional receipt
					// adding PANINVALID/PANAPPLIED/PANNOTAVL count to respective Vector for respective BATCH Record

					String tempPanSt = null;
					if (EmployeePan.equals(PAN_NOT_AVAILABLE))
					{
						//fvO.receiptPanNotAvbl++;
						fvO.receiptSalPanNotAvbl++; 
						tempPanSt = "PAN not available";
					}
					else if (EmployeePan.equals(PAN_APPLIED))
					{
						//fvO.receiptPanApplied++;
						fvO.receiptSalPanApplied++;
						tempPanSt = "PAN applied";
					}
					else if (EmployeePan.equals(PAN_INVALID))
					{
						//fvO.receiptPanInvaild++;
						fvO.receiptSalPanInvaild++;
						tempPanSt = "Invalid PAN";
					}

					// changed on 1 Sept 	
					//  statisticFileSDRec.append(LineNo + "$" + DeducteeDetailRecNo + "$" + panErrorDesc + "*");

					if (FormValidator.generateTdsPANStatBuffer && Str_Buffer.getErrorCount() == 0)
					{
						if (fvO.batchNumberOfRecord == 0)
						{
							fvO.batchNumberOfRecord = Integer.parseInt(BH_BatchNo.trim());
							Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatFileHeader());
							Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureStart(batchRecDataForPanStat.toString()));
							batchRecDataForPanStat = new StringBuffer();
							Str_Buffer.appendPANStat("<TR>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + tempPanSt + "</TD>");
							Str_Buffer.appendPANStat("</TR>");
						}
						else if (fvO.batchNumberOfRecord == Integer.parseInt(BH_BatchNo.trim()))
						{
							Str_Buffer.appendPANStat("<TR>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=125>" + DeducteeDetailRecNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + tempPanSt + "</TD>");
							Str_Buffer.appendPANStat("</TR>");
						}
						else
						{
							fvO.batchNumberOfRecord = Integer.parseInt(BH_BatchNo.trim());
							Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureEnd(fileNamePrintedinStatRep));
							Str_Buffer.appendPANStat(obj_FileGenerator.createPANStatTableStructureStart(batchRecDataForPanStat.toString()));
							batchRecDataForPanStat = new StringBuffer();
							Str_Buffer.appendPANStat("<TR>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=75> " + LineNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  valign=top style='text-align:right' width=120>" + DeducteeDetailRecNo + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=188> " + EmployeePan + "</TD>");
							Str_Buffer.appendPANStat("<TD  ALIGN=LEFT width=180>" + tempPanSt + "</TD>");
							Str_Buffer.appendPANStat("</TR>");
						}
					}
				}
			

//				---------------Added by Nahush for validating Deductor PAN against PAN of deductee.
				
				if(!(EmployeePan.equals(PAN_NOT_AVAILABLE) || 
	                	 EmployeePan.equals(PAN_APPLIED) || 
	                	 EmployeePan.equals(PAN_INVALID)) && 
	                	 PANForThisBatch.equals(EmployeePan) &&
	                	 (UploadType.equals("R") || (UploadType.equals("C") && BatchUpdationIndicator.equals("1"))))
	                {
	                	if (paperReturnFile)
	                	{
	                		Str_Buffer.appendPaperWarning(LineNo + tab + "Salary Detail" + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + "NA" + tab + "NA" + tab + "NA" + tab + T_FV_4262_C + tab + T_FV_4262_M);
	                	}
	                	
	                	else
	                	{
	                		Str_Buffer.appendElectronicWarning(LineNo + tab + "Salary Detail" + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + "NA" + tab + "NA" + tab + "NA" + tab + T_FV_4262_C + tab + T_FV_4262_M);
	                	}
	                }
			
			
			
			
			}
			//	check EmployeePan --7

			//		check EmployeePanRefNo   ------ 8
			if (EmployeePanRefNo.equals(FIELD_NULL) || EmployeePanRefNo.equals(FIELD_SEPERATOR))
			{
			}
			/*
			 * Paper Return clause added on 06-oct-2006 as PAN Ref No. field is not present in Physical Form
			 */
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN) || paperReturnFile)
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN Ref. No." + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4126_C + tab + T_FV_4126_M);
			else if (EmployeePanRefNo.length() != 10 || EmployeePanRefNo.trim().length() != 10 || obj_FieldValidation.isAlphaNum(EmployeePanRefNo))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "PAN Ref. No." + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4010_C + tab + T_FV_4010_M);
			}
			//		check EmployeePanRefNo --8

			//		check of EmployeeName   ----   9
			if (EmployeeName.equals(FIELD_NULL) || EmployeeName.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
				{
					/*
					 * Code modified on 06-oct-2006 for Paper Return Relaxation of Employee Name
					 */
					if (paperReturnFile)
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4012_C + tab + T_FV_4012_M);
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of Employee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4012_C + tab + T_FV_4012_M);
				}
			}
			else
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of Employee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4137_C + tab + T_FV_4137_M);
				else if (EmployeeName.length() <= 75 || EmployeeName.trim().length() == 0)
				{
					if (obj_FieldValidation.isValidCharString(EmployeeName))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of Employee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4012_C + tab + T_FV_4012_M);
					}
				}
				else
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Name of Employee" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4012_C + tab + T_FV_4012_M);
				}
			}
			//				check EmployeeName 

			// check for Category ---- 10
			if (EmployeeCategory.equals(FIELD_NULL) || EmployeeCategory.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
				{
					/*
					 * Code modified on 06-oct-2006 for Paper Return Relaxation of Category
					 */
					if (paperReturnFile)
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4217_C + tab + T_FV_4217_M);
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Category" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4217_C + tab + T_FV_4217_M);
				}
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Category" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4218_C + tab + T_FV_4218_M);
			else if (EmployeeCategory.length() > 1 || EmployeeCategory.trim().length() == 0 || obj_FieldValidation.isValidCharString(EmployeeCategory))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Category" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4217_C + tab + T_FV_4217_M);
			}
			else if (!EmployeeCategory.equals("W") && !EmployeeCategory.equals("S") && !EmployeeCategory.equals("G") && !(EmployeeCategory.equals("O")&& Integer.parseInt(FinancialYr)>=201112))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Category" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4217_C + tab + T_FV_4217_M);
			}
			// check for Category

			//check for Period of Employment From - Date    -------  11
			boolean invalidEmpFrmDate = false;
			if (PeriodEmploymentFrm.equals(FIELD_NULL) || PeriodEmploymentFrm.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);

				invalidEmpFrmDate = true;
			}
			else if (PeriodEmploymentFrm.length() == 8 && PeriodEmploymentFrm.trim().length() == 8)
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4139_C + tab + T_FV_4139_M);
				else if (obj_FieldValidation.isInt(PeriodEmploymentFrm))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
					invalidEmpFrmDate = true;
				}
				else if (obj_FieldValidation.isDate(PeriodEmploymentFrm))
				{
					/*
					 * Code modified on 06-oct-2006 for Paper Return Relaxation of from date
					 */
					if (paperReturnFile)
					{
						if (PeriodEmploymentFrm.equals(paperRetDateBankChalnDefValue))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4014_C + tab + T_FV_4014_M);
							invalidEmpFrmDate = true;
						}
						else
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
							invalidEmpFrmDate = true;
						}
					}
					else
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
						invalidEmpFrmDate = true;
					}
				}
				else if (!paperReturnFile) // commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					if (obj_FieldValidation.isDateGreaterThenRRRDatePresentDate(PeriodEmploymentFrm, RRRDatePresentDate))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
						invalidEmpFrmDate = true;
					}
					else
					{
						Calendar today = Calendar.getInstance();
						Calendar cal =
							new GregorianCalendar(
								Integer.parseInt(PeriodEmploymentFrm.substring(4)),
								Integer.parseInt(PeriodEmploymentFrm.substring(2, 4)) - 1,
								Integer.parseInt(PeriodEmploymentFrm.substring(0, 2)));

						if (!(cal.before(today)))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
							invalidEmpFrmDate = true;
						}
						else if (obj_FieldValidation.employmentFromDateBeforeQuatEnd(PeriodEmploymentFrm, FinancialYr, Qperiod))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
						}
					}
				}
				else if (paperReturnFile) // commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					if (obj_FieldValidation.isDateGreaterThenRRRDatePresentDate(PeriodEmploymentFrm, RRRDatePresentDate))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4014_C + tab + T_FV_4014_M);
						invalidEmpFrmDate = true;
					}
					else
					{
						Calendar today = Calendar.getInstance();
						Calendar cal =
							new GregorianCalendar(
								Integer.parseInt(PeriodEmploymentFrm.substring(4)),
								Integer.parseInt(PeriodEmploymentFrm.substring(2, 4)) - 1,
								Integer.parseInt(PeriodEmploymentFrm.substring(0, 2)));

						if (!(cal.before(today)))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4014_C + tab + T_FV_4014_M);
							invalidEmpFrmDate = true;
						}
						else if (obj_FieldValidation.employmentFromDateBeforeQuatEnd(PeriodEmploymentFrm, FinancialYr, Qperiod))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4014_C + tab + T_FV_4014_M);
							invalidEmpFrmDate = true;
						}
					}
				}
			}
			else
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment From - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4014_C + tab + T_FV_4014_M);
				invalidEmpFrmDate = true;
			}
			//	check for Period of Employment From - Date

			// 	check for Period of Employment To - Date   ----  12

			if (PeriodEmploymentTo.equals(FIELD_NULL) || PeriodEmploymentTo.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
			}
			else if (PeriodEmploymentTo.length() == 8 && PeriodEmploymentTo.trim().length() == 8)
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4140_C + tab + T_FV_4140_M);
				else if (obj_FieldValidation.isInt(PeriodEmploymentTo))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
				}
				else if (obj_FieldValidation.isDate(PeriodEmploymentTo))
				{
					/*
					 * Code modified on 06-oct-2006 for Paper Return Relaxation of to date
					 */
					if (paperReturnFile)
					{
						if (PeriodEmploymentTo.equals(paperRetDateBankChalnDefValue))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
						else
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
					}
					else
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
					}
				}
				else if (!paperReturnFile) // commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					if (obj_FieldValidation.isDateGreaterThenRRRDatePresentDate(PeriodEmploymentTo, RRRDatePresentDate))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
					}
					else if (invalidEmpFrmDate == false)
					{
						Calendar today = Calendar.getInstance();
						Calendar cal =
							new GregorianCalendar(
								Integer.parseInt(PeriodEmploymentTo.substring(4)),
								Integer.parseInt(PeriodEmploymentTo.substring(2, 4)) - 1,
								Integer.parseInt(PeriodEmploymentTo.substring(0, 2)));
						Calendar cal1 =
							new GregorianCalendar(
								Integer.parseInt(PeriodEmploymentFrm.substring(4)),
								Integer.parseInt(PeriodEmploymentFrm.substring(2, 4)) - 1,
								Integer.parseInt(PeriodEmploymentFrm.substring(0, 2)));
						if (!(cal.before(today)))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
						else if (invalidEmpFrmDate == false && cal.before(cal1))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
						/*
						                             * code commented to allow To-date to have any value upto the financial
						                             * year but should be greater than From date
						                             */
						/*else if (obj_FieldValidation.employmentDateWithinFinQuat(PeriodEmploymentTo, FinancialYr, Qperiod))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						 }
						*/
						else if (!obj_FieldValidation.isDateBeforeFinYearEndDate(PeriodEmploymentTo, FinancialYr))
						{
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Period of Employment To - Date" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}

					}
				}
				else if (paperReturnFile) // commented on 10-Oct-05 By Mayank Paper Return Changes
				{
					if (obj_FieldValidation.isDateGreaterThenRRRDatePresentDate(PeriodEmploymentTo, RRRDatePresentDate))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4015_C + tab + T_FV_4015_M);
					}
					else if (invalidEmpFrmDate == false)
					{
						Calendar today = Calendar.getInstance();
						Calendar cal =
							new GregorianCalendar(
								Integer.parseInt(PeriodEmploymentTo.substring(4)),
								Integer.parseInt(PeriodEmploymentTo.substring(2, 4)) - 1,
								Integer.parseInt(PeriodEmploymentTo.substring(0, 2)));
						Calendar cal1 =
							new GregorianCalendar(
								Integer.parseInt(PeriodEmploymentFrm.substring(4)),
								Integer.parseInt(PeriodEmploymentFrm.substring(2, 4)) - 1,
								Integer.parseInt(PeriodEmploymentFrm.substring(0, 2)));
						if (!(cal.before(today)))
						{
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
						else if (invalidEmpFrmDate == false && cal.before(cal1))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}

						/*
						 * code commented to allow To-date to have any value upto the financial
						 * year but should be greater than From date
						 */

						/*else if (obj_FieldValidation.employmentDateWithinFinQuat(PeriodEmploymentTo, FinancialYr, Qperiod))
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}*/
						else if (!obj_FieldValidation.isDateBeforeFinYearEndDate(PeriodEmploymentTo, FinancialYr))
						{
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4015_C + tab + T_FV_4015_M);
						}
					}
				}
			}
			else
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4015_C + tab + T_FV_4015_M);
			}
			//			check for Period of Employment To - Date

			//     Validating TotalSalaryExeclud333n334   --- 13
			boolean validTotalSalaryExeclud333n334 = false;
			if (TotalSalaryExeclud333n334.equals(FIELD_NULL) || TotalSalaryExeclud333n334.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total amount of salary " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4011_C + tab + T_FV_4011_M);
			}
			else
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total amount of salary " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4016_C + tab + T_FV_4016_M);
				else if (TotalSalaryExeclud333n334.length() <= 15)
				{
					if (obj_FieldValidation.isDecimalNumber(TotalSalaryExeclud333n334))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total amount of salary " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4011_C + tab + T_FV_4011_M);
					else
						validTotalSalaryExeclud333n334 = true;
				}
				else
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total amount of salary " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4011_C + tab + T_FV_4011_M);
			}
			//	   Validating TotalSalaryExeclud333n334

			//		Validate Profit lieu of salary under sec 17(3) ----  14  Filler field,  Filler-8
			if (!ProfitSalSec17.equals(FIELD_NULL) && !ProfitSalSec17.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Filler 8" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4019_C + tab + T_FV_4019_M);
			}
			//		Validate Profit lieu of salary under sec 17(3)

			//Validate Count of Deductee Section 16   -----  15
			boolean validCountDeducteeSec16 = false;
			if (CountDeducteeSec16.equals(FIELD_NULL) || CountDeducteeSec16.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4024_C + tab + T_FV_4024_M);
			}
			else if (CountDeducteeSec16.length() <= 15)
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4149_C + tab + T_FV_4149_M);
				else if (obj_FieldValidation.isInt(CountDeducteeSec16))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4024_C + tab + T_FV_4024_M);
				}
				else if (Integer.parseInt(CountDeducteeSec16.trim()) > sec16Identification.length)
				{
                    /*
                     * code modified to allow one more row in sec 16 
                     * for paper return with default section Id
                     */
					if (paperReturnFile)
					{
						if (Integer.parseInt(CountDeducteeSec16.trim()) > (sec16Identification.length + 1))
							Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4024_C + tab + T_FV_4024_M);
						else
						{
							fvO.setPaperReturnRelax(true);
							Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4024_C + tab + T_FV_4024_M);
						}
					}
					else
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4024_C + tab + T_FV_4024_M);
				}
				else
					validCountDeducteeSec16 = true;
			}
			else
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Section 16 " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4024_C + tab + T_FV_4024_M);
			}
			//Validate Count of Deductee Section 16 	

			//Validate Gross Total of deduction under section 16   --------- 16
			boolean validGrossTotalDeducteeSec16 = false;
			if (GrossTotalDeducteeSec16.equals(FIELD_NULL) || GrossTotalDeducteeSec16.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4025_C + tab + T_FV_4025_M);
			}
			else if (GrossTotalDeducteeSec16.length() <= 15)
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4150_C + tab + T_FV_4150_M);
				else if (obj_FieldValidation.isDecimalNumber(GrossTotalDeducteeSec16))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4025_C + tab + T_FV_4025_M);
				}
				else // if (!paperReturnFile)  commented on 10-Oct-05 By Mayank Paper Return Changes
					{
					if (validCountDeducteeSec16)
					{
						if ((Long.parseLong(CountDeducteeSec16.trim()) == 0) && (Double.parseDouble(GrossTotalDeducteeSec16.trim()) != 0))
						{
							if (paperReturnFile)
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4025_C + tab + T_FV_4025_M);
								validGrossTotalDeducteeSec16 = true;
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4025_C + tab + T_FV_4025_M);
						}
						else if ((Long.parseLong(CountDeducteeSec16.trim()) > 0) && (Double.parseDouble(GrossTotalDeducteeSec16.trim()) == 0))
						{
							if (paperReturnFile)
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4025_C + tab + T_FV_4025_M);
								validGrossTotalDeducteeSec16 = true;
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4025_C + tab + T_FV_4025_M);
						}
						else
							validGrossTotalDeducteeSec16 = true;
					}
					else
						validGrossTotalDeducteeSec16 = true;
				}
			}
			else
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Total Deduction under section 16' under  associated ' Salary Details  - Section 16 Detail ' " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4025_C + tab + T_FV_4025_M);
			}
			//Validate Gross Total of deduction under section 16

			//Validate Income Chargeable under the Head Salaries. -------- 17
			boolean validIncomeChargeableUderTheHeadSalaries = false;
			if (IncomeChargeableUderTheHeadSalaries.equals(FIELD_NULL) || IncomeChargeableUderTheHeadSalaries.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income chargeable under the head Salaries (332-333)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4026_C + tab + T_FV_4026_M);
			}
			else
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income chargeable under the head Salaries (332-333)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4151_C + tab + T_FV_4151_M);
				else if (IncomeChargeableUderTheHeadSalaries.length() <= 15)
				{
					if (obj_FieldValidation.isDecimalNumber(IncomeChargeableUderTheHeadSalaries))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income chargeable under the head Salaries (332-333)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4026_C + tab + T_FV_4026_M);
					}
					else // if (!paperReturnFile)  commented on 10-Oct-05 By Mayank Paper Return Changes
						{
						if (validTotalSalaryExeclud333n334 && validGrossTotalDeducteeSec16)
						{
							if ((Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim()) * 100.0)
								< (-1000.0 + (Double.parseDouble(TotalSalaryExeclud333n334.trim()) * 100.0) - (Double.parseDouble(GrossTotalDeducteeSec16.trim()) * 100.0))
								|| (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim()) * 100.0)
									> (1000.0 + (Double.parseDouble(TotalSalaryExeclud333n334.trim()) * 100.0) - (Double.parseDouble(GrossTotalDeducteeSec16.trim()) * 100.0)))
							{
								if (paperReturnFile) // && (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim()) == 0))
								{
									fvO.setPaperReturnRelax(true);
									Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4023_C + tab + T_FV_4023_M);
									validIncomeChargeableUderTheHeadSalaries = true;
								}
								else
									Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income chargeable under the head Salaries (332-333)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4023_C + tab + T_FV_4023_M);
							}
							else
								validIncomeChargeableUderTheHeadSalaries = true;
						}
					}
				}
				else
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income chargeable under the head Salaries (332-333)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4026_C + tab + T_FV_4026_M);
				}
			}
			//Income chargeable under the head Salaries 

			//Income ( including loss from house property) under any head other than  income under the head "salaries" offered for TDS  --- 18
			boolean validIncomeLossFrmHouse = false;
			if (IncomeLossFrmHouse.equals(FIELD_NULL) || IncomeLossFrmHouse.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income ( including loss from house property) under any head other than income under the head 'salaries' offered for TDS [section 192(2B)]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4027_C + tab + T_FV_4027_M);
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income ( including loss from house property) under any head other than income under the head 'salaries' offered for TDS [section 192(2B)]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4152_C + tab + T_FV_4152_M);
			else if (IncomeLossFrmHouse.length() <= 15)
			{
				if (obj_FieldValidation.isPositiveNegativeDecimalNumber(IncomeLossFrmHouse))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income ( including loss from house property) under any head other than income under the head 'salaries' offered for TDS [section 192(2B)]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4027_C + tab + T_FV_4027_M);
				else
					validIncomeLossFrmHouse = true;
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income ( including loss from house property) under any head other than income under the head 'salaries' offered for TDS [section 192(2B)]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4027_C + tab + T_FV_4027_M);
			//Income ( including loss from house property) under any head other than	

			//Gross Total Income (211 + 212)  ----- 19
			boolean validGrossTotIncome = false;
			boolean validGrossTotIncome2 = false;
			if (GrossTotIncome.equals(FIELD_NULL) || GrossTotIncome.equals(FIELD_SEPERATOR))
			{
				if (!TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4028_C + tab + T_FV_4028_M);
			}
			else if (TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4210_C + tab + T_FV_4210_M);
			}
			else if (GrossTotIncome.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(GrossTotIncome))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4028_C + tab + T_FV_4028_M);
				}
				else // if (!paperReturnFile) commented on 10-Oct-05 By Mayank Paper Return Changes
					{
					validGrossTotIncome2 = true;
					SummationGrossTotIncome = SummationGrossTotIncome + Double.parseDouble(GrossTotIncome.trim());

					if (ModeSD.equals("A"))
					{
						if (validIncomeChargeableUderTheHeadSalaries && validIncomeLossFrmHouse)
						{
							if ((Double.parseDouble(GrossTotIncome.trim()) * 100.0)
								< (-1000.0 + (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim()) * 100.0) + (Double.parseDouble(IncomeLossFrmHouse.trim()) * 100.0))
								|| (Double.parseDouble(GrossTotIncome.trim()) * 100.0)
									> (1000.0 + (Double.parseDouble(IncomeChargeableUderTheHeadSalaries.trim()) * 100.0) + (Double.parseDouble(IncomeLossFrmHouse.trim()) * 100.0)))
							{
								if (paperReturnFile) // && (Double.parseDouble(GrossTotIncome.trim()) == 0))
								{
									fvO.setPaperReturnRelax(true);
									Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4020_C + tab + T_FV_4020_M);
									validGrossTotIncome = true;
								}
								else
									Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4020_C + tab + T_FV_4020_M);
							}
							else
								validGrossTotIncome = true;
						}
					}
				}
				//  commented on 10-Oct-05 By Mayank Paper Return Changes
				//            else
				//            {
				//               validGrossTotIncome2 = true;
				//               SummationGrossTotIncome = SummationGrossTotIncome + Double.parseDouble(GrossTotIncome.trim());
				//            }
			}
			else
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4028_C + tab + T_FV_4028_M);
			}
			//Gross Total Income (211 + 212)

			// Last Gross Total Income  ----- 20
			if (LastGrossTotIncome.equals(FIELD_NULL) || LastGrossTotIncome.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Last Gross Total Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4170_C + tab + T_FV_4170_M);
			}
			else if (ModeSD.equals("A"))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Last Gross Total Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4171_C + tab + T_FV_4171_M);
			else if (LastGrossTotIncome.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(LastGrossTotIncome))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Last Gross Total Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4170_C + tab + T_FV_4170_M);
				}
				else if (validGrossTotIncome2)
				{
					if (Double.parseDouble(GrossTotIncome.trim()) != Double.parseDouble(LastGrossTotIncome.trim()))
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Last Gross Total Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4164_C + tab + T_FV_4164_M);
				}
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Last Gross Total Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4170_C + tab + T_FV_4170_M);
			//Last Gross Total Income		

			//			Validate Count of deductee - Chapter VI Details -----  21
			boolean validCountDeducteeChapVIDetails = false;
			if (CountDeducteeChapVIDetails.equals(FIELD_NULL) || CountDeducteeChapVIDetails.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail  " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4029_C + tab + T_FV_4029_M);
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4153_C + tab + T_FV_4153_M);
			else if (CountDeducteeChapVIDetails.length() <= 9)
			{
				if (obj_FieldValidation.isInt(CountDeducteeChapVIDetails))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4029_C + tab + T_FV_4029_M);
				}
				else if (Long.parseLong(CountDeducteeChapVIDetails.trim()) > secVIAIdentification.length)
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4029_C + tab + T_FV_4029_M);
				else
					validCountDeducteeChapVIDetails = true;
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Count of ' Salary Details  - Chapter VI-A Detail ' Records  associated with Deductee - Chapter VIA Detail " + tab + "NA" + tab + DeducteeDetailRecNo + T_FV_4029_C + tab + T_FV_4029_M);
			//	Validate Count of deductee - Chapter VI Details

			// Validate Gross Total of Deductee - Chapter VI details   ------- 22
			boolean validGrossTotDeducteeChapVIDetails = false;
			if (GrossTotDeducteeChapVIDetails.equals(FIELD_NULL) || GrossTotDeducteeChapVIDetails.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4030_C + tab + T_FV_4030_M);
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4154_C + tab + T_FV_4154_M);
			else if (GrossTotDeducteeChapVIDetails.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(GrossTotDeducteeChapVIDetails))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4030_C + tab + T_FV_4030_M);
				else // if (!paperReturnFile) commented on 10-Oct-05 By Mayank Paper Return Changes
					{
					if (validCountDeducteeChapVIDetails)
					{
						if ((Long.parseLong(CountDeducteeChapVIDetails.trim()) == 0) && (Double.parseDouble(GrossTotDeducteeChapVIDetails.trim()) != 0))
						{
							if (paperReturnFile)
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4030_C + tab + T_FV_4030_M);
								validGrossTotDeducteeChapVIDetails = true;
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4030_C + tab + T_FV_4030_M);
						}
						else
							validGrossTotDeducteeChapVIDetails = true;
					}
					else
						validGrossTotDeducteeChapVIDetails = true;
				}
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail" + tab + "NA" + tab + CurrentlocalSDNumber + tab + tab + T_FV_4030_C + tab + T_FV_4030_M);
			//	Validate Gross Total of Deductee - Chapter VI details

			//	Total Taxable Income ( 213 - 217)    ---- 23
			boolean validTotTaxableIncome = false;
			if (TotTaxableIncome340344.equals(FIELD_NULL) || TotTaxableIncome340344.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4031_C + tab + T_FV_4031_M);
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4155_C + tab + T_FV_4155_M);
			else if (TotTaxableIncome340344.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(TotTaxableIncome340344))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4031_C + tab + T_FV_4031_M);
				}
				else // if (!paperReturnFile) commented on 10-Oct-05 By Mayank Paper Return Changes
					{
					if (validGrossTotIncome && validGrossTotDeducteeChapVIDetails)
					{
						if ((Double.parseDouble(TotTaxableIncome340344.trim()) * 100.0)
							< (-1000.0 + (Double.parseDouble(GrossTotIncome.trim()) * 100.0) - (Double.parseDouble(GrossTotDeducteeChapVIDetails.trim()) * 100.0))
							|| (Double.parseDouble(TotTaxableIncome340344.trim()) * 100.0)
								> (1000.0 + (Double.parseDouble(GrossTotIncome.trim()) * 100.0) - (Double.parseDouble(GrossTotDeducteeChapVIDetails.trim()) * 100.0)))
						{
							if (paperReturnFile) // && (Double.parseDouble(TotTaxableIncome340344.trim()) == 0))
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4040_C + tab + T_FV_4040_M);
								validTotTaxableIncome = true;
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4040_C + tab + T_FV_4040_M);
						}
						else
							validTotTaxableIncome = true;
					}
					//Added By AMI For FVU 3.0
					
					//Commented by Dhanya on 29/04/2011 as the data type of 'sumOfSalDelTotTaxableIncome' is changed to BigDecimal from 'double'.
					//formVal.sumOfSalDelTotTaxableIncome = formVal.sumOfSalDelTotTaxableIncome + Double.parseDouble(TotTaxableIncome340344);
					formVal.sumOfSalDelTotTaxableIncome = formVal.sumOfSalDelTotTaxableIncome.add(new BigDecimal(TotTaxableIncome340344.trim()));
					//Ends addition by Dhanya on 29/04/2011 for the data type change
				}
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Taxable Income " + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4031_C + tab + T_FV_4031_M);
			//		Total Taxable Income ( 213 - 217)

		
			//		Income Tax on Total Income  --------   24
			boolean validIncomeTaxOnTotIncome = false;
			if (IncomeTaxOnTotIncome.equals(FIELD_NULL) || IncomeTaxOnTotIncome.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4032_C + tab + T_FV_4032_M);
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4156_C + tab + T_FV_4156_M);
			else if (IncomeTaxOnTotIncome.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(IncomeTaxOnTotIncome))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4032_C + tab + T_FV_4032_M);
				}
				else // if (!paperReturnFile) commented on 10-Oct-05 By Mayank Paper Return Changes
					{
					if (validTotTaxableIncome)
					{
						
						if (Double.parseDouble(IncomeTaxOnTotIncome.trim()) > Double.parseDouble(TotTaxableIncome340344.trim()))
						{
							
							if (paperReturnFile) // && (Double.parseDouble(IncomeTaxOnTotIncome.trim()) == 0))
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4214_C + tab + T_FV_4214_M);
								validIncomeTaxOnTotIncome = true;
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4214_C + tab + T_FV_4214_M);
						}
						else
							validIncomeTaxOnTotIncome = true;
					}
					else
						validIncomeTaxOnTotIncome = true;
				}
				// commented on 10-Oct-05 By Mayank Paper Return Changes
				//            else
				//               validIncomeTaxOnTotIncome = true;
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4032_C + tab + T_FV_4032_M);
			//Income Tax on Total Income

			// Validate Surcharge ---- 25
			boolean validSurcharge = false;
			if (Surcharge.equals(FIELD_NULL) || Surcharge.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4219_C + tab + T_FV_4219_M);
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4220_C + tab + T_FV_4220_M);
			else if (Surcharge.length() <= 15)
			{
						
				if (obj_FieldValidation.isDecimalNumber(Surcharge))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4219_C + tab + T_FV_4219_M);
				}
				
				
				/*
				 * code added on 18oct 2006 to generate warning file in 
				 * case value of surcharge is greater then total taxable income for paperReturnFile
				 */
				
				else if (validTotTaxableIncome && paperReturnFile)
				{
					if (Double.parseDouble(Surcharge.trim()) > Double.parseDouble(TotTaxableIncome340344.trim()))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4215_C + tab + T_FV_4215_M);
						validSurcharge = true;
					}
					else
						validSurcharge = true;
				}
				else
					validSurcharge = true;
				
				
				//M02_B
				//Check for surcharge > totaltaxableincome for electronic files
				if(validTotTaxableIncome && !paperReturnFile)
				{
					if (Double.parseDouble(Surcharge.trim()) > Double.parseDouble(TotTaxableIncome340344.trim()))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4215_C + tab + T_FV_4215_M);
					}
				}
				//M02_E
				
				
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Surcharge" + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4219_C + tab + T_FV_4219_M);

			// Validate Surcharge

			//          Validate Cess ---- 26
			boolean validCess = false;
			if (Cess.equals(FIELD_NULL) || Cess.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4223_C + tab + T_FV_4223_M);
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4224_C + tab + T_FV_4224_M);

			else if (Cess.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(Cess))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4223_C + tab + T_FV_4223_M);
				}
				
				else if (validTotTaxableIncome && paperReturnFile)
				{
					if (Double.parseDouble(Cess.trim()) > Double.parseDouble(TotTaxableIncome340344.trim()))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "Education Cess" + tab + DeducteeDetailRecNo + tab + T_FV_4206_C + tab + T_FV_4206_M);
						validCess = true;
					}
					else
						validCess = true;
				}
				else
					validCess = true;
				
				
				//M02_B
				//Check for Cess > totaltaxableincome for electronic files
				if (validTotTaxableIncome && !paperReturnFile)
				{
					if (Double.parseDouble(Cess.trim()) > Double.parseDouble(TotTaxableIncome340344.trim()))
					{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4206_C + tab + T_FV_4206_M);
					}
				}
				//check for  income tax on total income + surcharge + cess > Total taxable income
				if(Double.parseDouble(IncomeTaxOnTotIncome.trim()) + Double.parseDouble(Cess.trim()) + Double.parseDouble(Surcharge.trim()) > Double.parseDouble(TotTaxableIncome340344.trim()))
				{
						Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax on Total Income" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4279_C + tab + T_FV_4279_M);
				
				}
				
				//M02_E
				
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Education Cess" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4223_C + tab + T_FV_4223_M);
			// Validate Cess

			//    Validating IncomeTaxRelief ----------  27
			boolean validIncomeTaxRelief = false;
			if (IncomeTaxRelief.equals(FIELD_NULL) || IncomeTaxRelief.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax Relief u/s 89 when salary etc is paid in arrear or advance" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4073_C + tab + T_FV_4073_M);
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax Relief u/s 89 when salary etc is paid in arrear or advance" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4074_C + tab + T_FV_4074_M);
			else if (IncomeTaxRelief.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(IncomeTaxRelief))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax Relief u/s 89 when salary etc is paid in arrear or advance" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4073_C + tab + T_FV_4073_M);
				}
				else
					validIncomeTaxRelief = true;
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Income Tax Relief u/s 89 when salary etc is paid in arrear or advance" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4073_C + tab + T_FV_4073_M);
			//		Validating IncomeTaxRelief				

			//Net Income Tax payable (341+342+343-344)  ------ 28
			boolean validNetTaxPayable = false;
			if (NetTaxPayable.equals(FIELD_NULL) || NetTaxPayable.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (341+342+343-344)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4035_C + tab + T_FV_4035_M);
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (341+342+343-344)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4159_C + tab + T_FV_4159_M);
			else if (NetTaxPayable.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(NetTaxPayable))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (341+342+343-344)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4035_C + tab + T_FV_4035_M);
				}
				else //if (!paperReturnFile) commented on 10-Oct-05 By Mayank Paper Return Changes
					{
					if (validIncomeTaxOnTotIncome && validSurcharge && validCess && validIncomeTaxRelief)
					{
						if ((Double.parseDouble(NetTaxPayable.trim()) * 100.0)
							< (
								- 1000.0
								+ (Double.parseDouble(IncomeTaxOnTotIncome.trim()) * 100.0)
								+ (Double.parseDouble(Surcharge.trim()) * 100.0)
								+ (Double.parseDouble(Cess.trim()) * 100.0)
								- (Double.parseDouble(IncomeTaxRelief.trim()) * 100.0))
							|| (Double.parseDouble(NetTaxPayable.trim()) * 100.0)
								> (1000.0
									+ (Double.parseDouble(IncomeTaxOnTotIncome.trim()) * 100.0)
									+ (Double.parseDouble(Surcharge.trim()) * 100.0)
									+ (Double.parseDouble(Cess.trim()) * 100.0)
									- (Double.parseDouble(IncomeTaxRelief.trim()) * 100.0)))
						{
							if (paperReturnFile) // && (Double.parseDouble(NetTaxPayable.trim()) == 0))
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + "NA" + tab + DeducteeDetailRecNo + tab + T_FV_4202_C + tab + T_FV_4202_M);
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (341+342+343-344)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4202_C + tab + T_FV_4202_M);
						}
						else
							validNetTaxPayable = true;
					}
				}
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Net Income Tax payable (341+342+343-344)" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4035_C + tab + T_FV_4035_M);

			//Net Income Tax payable (341+342+343-344) 			  		

			//validate TotTDSWholeYear ----  29
			boolean validTotTDSWholeYear = false;
			if (TotTDSWholeYear.equals(FIELD_NULL) || TotTDSWholeYear.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4225_C + tab + T_FV_4225_M);
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4226_C + tab + T_FV_4226_M);

			else if (TotTDSWholeYear.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(TotTDSWholeYear))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4225_C + tab + T_FV_4225_M);
				}
				else
					validTotTDSWholeYear = true;
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Total Amount of Tax Deducted at source for the whole year" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4225_C + tab + T_FV_4225_M);

			//validate TotTDSWholeYear

			//Validate ShortfallExcessTaxDeduc ---- 30
			boolean validShortfallExcessTaxDeduc = false;
			if (ShortfallExcessTaxDeduc.equals(FIELD_NULL) || ShortfallExcessTaxDeduc.equals(FIELD_SEPERATOR))
			{
				if (ModeSD.equals("A"))
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Shortfall in tax deduction(+)/Excess tax deduction(-) [345-346]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4227_C + tab + T_FV_4227_M);
			}
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Shortfall in tax deduction(+)/Excess tax deduction(-) [345-346]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4228_C + tab + T_FV_4228_M);
			else if (ShortfallExcessTaxDeduc.length() <= 15)
			{
				if (obj_FieldValidation.isPositiveNegativeDecimalNumber(ShortfallExcessTaxDeduc))
				{
					Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Shortfall in tax deduction(+)/Excess tax deduction(-) [345-346]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4227_C + tab + T_FV_4227_M);
				}
				else
				{
					if (validNetTaxPayable && validTotTDSWholeYear)
					{
						if ((Double.parseDouble(ShortfallExcessTaxDeduc.trim()) * 100.0)
							< (-1000.0 + (Double.parseDouble(NetTaxPayable.trim()) * 100.0) - (Double.parseDouble(TotTDSWholeYear.trim()) * 100.0))
							|| (Double.parseDouble(ShortfallExcessTaxDeduc.trim()) * 100.0)
								> (1000.0 + (Double.parseDouble(NetTaxPayable.trim()) * 100.0) - (Double.parseDouble(TotTDSWholeYear.trim()) * 100.0)))
						{
							/*
							 * Code modified on 09-oct-2006 for Paper Return Relaxation of Shortfall/excess
							 * tax deduction
							 */

							if (paperReturnFile)
							{
								fvO.setPaperReturnRelax(true);
								Str_Buffer.appendPaperWarning(LineNo + tab + BH_BatchNo + tab + DeducteeDetailRecNo + tab + T_FV_4242_C + tab + T_FV_4242_M);
							}
							else
								Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Shortfall in tax deduction(+)/Excess tax deduction(-) [345-346]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4242_C + tab + T_FV_4242_M);
						}
						else
							validShortfallExcessTaxDeduc = true;
					}
				}
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Shortfall in tax deduction(+)/Excess tax deduction(-) [345-346]" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4227_C + tab + T_FV_4227_M);

			//Validate ShortfallExcessTaxDeduc

			//		check of Remark1   ----- 31
			if (Remark1.equals(FIELD_NULL) || Remark1.equals(FIELD_SEPERATOR))
			{
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Remarks1" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4041_C + tab + T_FV_4041_M);
			/*
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4165_C + tab + T_FV_4165_M);
			else if (Remark1.length() > 75)
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4041_C + tab + T_FV_4041_M);
			}*/
			//		check of Remark1

			//		check of Remark2  ---------   32
			if (Remark2.equals(FIELD_NULL) || Remark2.equals(FIELD_SEPERATOR))
			{
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Remarks2" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4042_C + tab + T_FV_4042_M);
			/*
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4166_C + tab + T_FV_4166_M);
			else if (Remark2.length() > 75)
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4042_C + tab + T_FV_4042_M);
			}*/
			//		check of Remark2

			//		check of Remark3   ------   33
			if (Remark3.equals(FIELD_NULL) || Remark3.equals(FIELD_SEPERATOR))
			{
			}
			else
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "Remarks3" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4043_C + tab + T_FV_4043_M);
			/*
			else if (ModeSD.equals("D") || TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4167_C + tab + T_FV_4167_M);
			else if (Remark3.length() > 75)
			{
				Str_Buffer.append(LineNo + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + CurrentlocalSDNumber + tab + T_FV_4043_C + tab + T_FV_4043_M);
			}
			*/
			//		check of Remark3

			// 		Checking if Summation of Gross Total Income specified at Batch Record equal to sum of Gross Total Income specified at deductee record
			if ((localCountOfSD == DeducteeCount) && !TransactionType.equals(TRANSACTIONTYPE_CORRECTION_PAN))
			{
				//   Log.tds_log.info("SummationGrossTotIncome : " + SummationGrossTotIncome + "\t\t GrossTotalIncomeSD : " + GrossTotalIncomeSD);
				// 16 July 05 Code  Changed ------ Explain Later ----------------
				//		if(SummationGrossTotIncome != Double.parseDouble(GrossTotalIncomeSD.trim()))
				//			Str_Buffer.append(lineNoOfBatchRec + tab + v_upload_Type + tab + "NA" + tab + "NA" + tab + tab + T_FV_2092_C + tab + T_FV_2092_M);
				//		d4 = Math.round((double)(d4 * 100)) /100.0;

				double doubValSummationGrossTotIncome = Math.round((double) (SummationGrossTotIncome * 100)) / 100.0;
				if (doubValSummationGrossTotIncome != Double.parseDouble(GrossTotalIncomeSD.trim()))
				{
					Str_Buffer.append(lineNoOfBatchRec + tab + v_upload_Type + tab + "Batch Total of - Gross Total Income as per Salary Detail" + tab + tab + tab + T_FV_2092_C + tab + T_FV_2092_M);
				}
			}
			// 		Checking if Summation of Gross Total Income specified at Batch Record equal to sum of Gross Total Income specified at deductee record

		} //try
		catch (Exception e)
		{			
			throw e;
		}
		fvO.returnRecordType = RecType;
		return;
	} //method Validate deductee details for annual file format.
	//		//////////    Validate Salary Statement Record END ////////////////

	// Validate Annual Section 16
	private void validateSection16(
		String Section16,
		int LineCount,
		String BH_BatchNo,
		String DeducteeDetailRecNo,
		String Sec16Count,
		String Sec16TotalAmount,
		int section16ValidCount,
		boolean paperReturnFile,
		StringBufferTemp obj_StringBuffer,
		String v_upload_Type
		)
		throws Exception
	{
		StringBufferTemp Str_Buffer;
		Str_Buffer = obj_StringBuffer;

		boolean NullField = false;
		int Count_Section16_fields = 1;
		boolean FieldFound;
		boolean Caret = false;
		boolean localErrorFlag = false;

		try
		{
			String Sec16_LineNo = null;
			String Sec16_RecType = null;
			String Sec16_BatchNo = null;
			String Sec16_DeducteeDetailRecNo = null;
			String Sec16_RecordNo = null;
			String Sec16_ID = null;
			String Sec16_DeductionAmount = null;
			String Sec16_Hash = null;

			FieldValidation obj_FieldValidation = new FieldValidation();

			StringTokenizer st_DD_Sec16 = new StringTokenizer(Section16, FIELD_SEPERATOR, true);

			int caretCounter = 0;
			while (st_DD_Sec16.hasMoreTokens())
			{
				String val = st_DD_Sec16.nextToken();
				NullField = false;
				FieldFound = false;
				if ((val.equals(FIELD_SEPERATOR) && Caret) || val.trim().length() == 0)
				{
					NullField = true;
					FieldFound = true;
				}
				if (val.equals(FIELD_SEPERATOR))
				{
					Caret = true;
					if (caretCounter == 0 && Count_Section16_fields == 1)
					{
						Count_Section16_fields++;
						Sec16_LineNo = "";
					}
					caretCounter++;
				}
				else
				{
					Caret = false;
					FieldFound = true;
				}

				if (Count_Section16_fields > 8)
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + tab + tab + T_FV_6001_C + tab + T_FV_6001_M);
					fvO.returnRecordType = RecType;
					return;
				}

				if (FieldFound)
				{
					switch (Count_Section16_fields)
					{
						case 1 :
							Sec16_LineNo = val;
							break;
						case 2 :
							Sec16_RecType = val;
							break;
						case 3 :
							Sec16_BatchNo = val;
							break;
						case 4 :
							Sec16_DeducteeDetailRecNo = val;
							break;
						case 5 :
							Sec16_RecordNo = val;
							break;
						case 6 :
							Sec16_ID = val;
							break;
						case 7 :
							Sec16_DeductionAmount = val;
							break;
						case 8 :
							Sec16_Hash = val;
							break;
					}
					Count_Section16_fields++;
				}
			}
			if (Sec16_DeductionAmount == null)
				Sec16_DeductionAmount = "";

			if (caretCounter != 7)
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + tab + tab + T_FV_6001_C + tab + T_FV_6001_M);
				fvO.returnRecordType = RecType;
				return;
			}

			//validation starts 

			if (Sec16_LineNo.equals(FIELD_NULL) || Sec16_LineNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				Sec16_LineNo = "-";
			}
			else if (Sec16_LineNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(Sec16_LineNo))
				{
					Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
					Sec16_LineNo = "-";
				}
				else if (Integer.parseInt(Sec16_LineNo.trim()) != LineCount)
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				}
			}
			else
			{
				Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				Sec16_LineNo = "-";
			}

			//	  check Sec16_LineNo
			//	  check RecType
			if (Sec16_RecType.equals(FIELD_NULL) || Sec16_RecType.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Section 16 Detail Record Type" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6023_C + tab + T_FV_6023_M);
			}
			else if (!(Sec16_RecType.equals(SECTION16_HEADER_IDENTIFIER)))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Section 16 Detail Record Type" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6023_C + tab + T_FV_6023_M);
			}
			//		check RecType

			//	  check BatchNo
			if (Sec16_BatchNo.equals(FIELD_NULL) || Sec16_BatchNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
			}
			else if (Sec16_BatchNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(Sec16_BatchNo))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
				}
				else if (Integer.parseInt(Sec16_BatchNo.trim()) != Integer.parseInt(BH_BatchNo.trim()))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6029_C + tab + T_FV_6029_M);
				}
			}
			else
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
			}

			//				check BatchNo
			//		check Sec16_DeducteeDetailRecNo
			if (Sec16_DeducteeDetailRecNo.equals(FIELD_NULL) || Sec16_DeducteeDetailRecNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + "NULL" + tab + T_FV_6008_C + tab + T_FV_6008_M);
				
			}
			else if (Sec16_DeducteeDetailRecNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(Sec16_DeducteeDetailRecNo))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);
					
				}
				else if (Integer.parseInt(Sec16_DeducteeDetailRecNo.trim()) != Integer.parseInt(DeducteeDetailRecNo.trim()))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);
					
				}
			}
			else
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);
			}

			//	  check Sec16_DeducteeDetailRecNo

			//	check DeducteeDetailRecNo
			if (Sec16_RecordNo.equals(FIELD_NULL) || Sec16_RecordNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail  - Section 16 Details Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6010_C + tab + T_FV_6010_M);
			}
			else if (Sec16_RecordNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(Sec16_RecordNo))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail  - Section 16 Details Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6010_C + tab + T_FV_6010_M);
				}
				else if (section16ValidCount != Integer.parseInt(Sec16_RecordNo.trim()))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail  - Section 16 Details Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6010_C + tab + T_FV_6010_M);
				}
			}
			else
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Salary Detail  - Section 16 Details Record No" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6010_C + tab + T_FV_6010_M);
			}

			//	  check DeducteeDetailRecNo

			//	check Section 16 I.D.
			boolean errUnique = false;
			boolean validSec16 = false;
			if (Sec16_ID.equals(FIELD_NULL) || Sec16_ID.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "section 16 section ID" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6013_C + tab + T_FV_6013_M);
			}
			else if (Sec16_ID.length() <= 15)
			{
				for (int localX = 0; localX < sec16Identification.length; localX++)
				{
					if (Sec16_ID.equals(sec16Identification[localX]))
					{
						validSec16 = true;
						break;
					}
				}
				/* 
				 * Code modified to allow default value 999 in sec ID for Paper Return , SD
				 */
				if (paperReturnFile)
				{
					if (Sec16_ID.equals(paperRetSecIDDefValue))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(Sec16_LineNo + tab + BH_BatchNo + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6013_C + tab + T_FV_6013_M);
						validSec16 = true;
					}
				}
				if (validSec16 == false)
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "section 16 section ID" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6013_C + tab + T_FV_6013_M);
				}

				if (validSec16)
				{
					for (int localI = 0; localI < section16ValidCount; localI++)
					{
						if (sec16Array[localI] != null && sec16Array[localI].equals(Sec16_ID))
						{
							errUnique = true;
							Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "section 16 section ID" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6025_C + tab + T_FV_6025_M);
							break;
						}
					}

					if (errUnique == false)
					{
						sec16Array[section16ValidCount - 1] = Sec16_ID;
					}
				}
			}
			else
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "section 16 section ID" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6013_C + tab + T_FV_6013_M);
			}

			//END	  check Section 16 I.D.

			// Check Total deduction Under sectionSection 16
			if (Sec16_DeductionAmount.equals(FIELD_NULL) || Sec16_DeductionAmount.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6018_C + tab + T_FV_6018_M);
				localErrorFlag = true;
			}
			else if (Sec16_DeductionAmount.length() <= 15)
			{
				if (obj_FieldValidation.isDecimalNumber(Sec16_DeductionAmount))
				{
					Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6018_C + tab + T_FV_6018_M);
					localErrorFlag = true;
				}
			}
			else
			{
				Str_Buffer.append(Sec16_LineNo + tab + v_upload_Type + tab + "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_6018_C + tab + T_FV_6018_M);
				localErrorFlag = true;
			}

			////validation ends
			//         if (!localErrorFlag && !paperReturnFile)

			if (!localErrorFlag)
			{
				sumSection16 = sumSection16 + Double.parseDouble(Sec16_DeductionAmount);
				/*
				 *  d4 = Math.round((double)(d4 * 100)) /100.0;	
				 *   16 July Code Changed 
				 */
				sumSection16 = Math.round((double) (sumSection16 * 100)) / 100.0;
				if (section16ValidCount == Integer.parseInt(Sec16Count.trim()) && (sumSection16 != Double.parseDouble(Sec16TotalAmount.trim())))
				{
					//  Log.tds_log.info("sumSection16 : " + sumSection16 + "\t\t Sec16TotalAmount : " + Sec16TotalAmount);
					if (paperReturnFile) // && (Double.parseDouble(Sec16TotalAmount.trim()) == 0))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(lineNoOfSalaryDetailRec + tab + BH_BatchNo + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_4045_C + tab + T_FV_4045_M);
					}
					else
						Str_Buffer.append(lineNoOfSalaryDetailRec + tab + v_upload_Type + tab + "Total Deduction under section 16" + tab + "NA" + tab + Sec16_DeducteeDetailRecNo + tab + T_FV_4045_C + tab + T_FV_4045_M);
				}
			}

		} //try
		catch (Exception e)
		{
			throw e;
		}
		fvO.returnRecordType = RecType;
		return;
	} // method ValidateAnnualSection16

	//	Validate Annual Section Chapter VI-A
	private void validateSectionVIA(
		String SectionVIA,
		int lineCount,
		String BH_BatchNo,
		String DeducteeDetailRecNo,
		String SecVIACount,
		String SecVIATotalAmount,
		int SecVIAValidCount,
		boolean paperReturnFile,
		StringBufferTemp obj_StringBuffer,
		String v_upload_Type)
		throws Exception
	{
		StringBufferTemp Str_Buffer;
		Str_Buffer = obj_StringBuffer;

		int Count_SectionVIA_fields = 1;
		boolean NullField = false;
		boolean FieldFound;
		boolean Caret = false;
		//			boolean localErrorFlag = false;
		try
		{
			String SecVIA_LineNo = null;
			String SecVIA_RecType = null;
			String SecVIA_BatchNo = null;
			String SecVIA_DeducteeDetailRecNo = null;
			String SecVIA_RecordNo = null;
			String SecVIA_ID = null;
			String SecVIA_TotAmount = null;
			//			String SecVIA_GrossAmount = null;
			//			String SecVIA_QualifyingAmount = null;
			//			String SecVIA_DeductionAmount = null;
			String SecVIA_Hash = null;

			FieldValidation obj_FieldValidation = new FieldValidation();

			StringTokenizer st_DD_SecVIA = new StringTokenizer(SectionVIA, FIELD_SEPERATOR, true);

			int caretCounter = 0;
			while (st_DD_SecVIA.hasMoreTokens())
			{
				String val = st_DD_SecVIA.nextToken();
				NullField = false;
				FieldFound = false;
				if ((val.equals(FIELD_SEPERATOR) && Caret) || val.trim().length() == 0)
				{
					NullField = true;
					FieldFound = true;
				}
				if (val.equals(FIELD_SEPERATOR))
				{
					Caret = true;
					if (caretCounter == 0 && Count_SectionVIA_fields == 1)
					{
						Count_SectionVIA_fields++;
						SecVIA_LineNo = "";
					}
					caretCounter++;
				}
				else
				{
					Caret = false;
					FieldFound = true;
				}

				if (Count_SectionVIA_fields > 8 /*10*/
					)
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + tab + tab + T_FV_6003_C + tab + T_FV_6003_M);
					fvO.returnRecordType = RecType;
					return;
				}
				if (FieldFound)
				{
					switch (Count_SectionVIA_fields)
					{
						case 1 :
							SecVIA_LineNo = val;
							break;
						case 2 :
							SecVIA_RecType = val;
							break;
						case 3 :
							SecVIA_BatchNo = val;
							break;
						case 4 :
							SecVIA_DeducteeDetailRecNo = val;
							break;
						case 5 :
							SecVIA_RecordNo = val;
							break;
						case 6 :
							SecVIA_ID = val;
							break;
						case 7 :
							SecVIA_TotAmount = val;
							break;
						case 8 :
							SecVIA_Hash = val;
							break;
					}
					Count_SectionVIA_fields++;
				}
			} //while 

			if (SecVIA_TotAmount == null)
				SecVIA_TotAmount = "";

			if (caretCounter != 7 /*9*/
				)
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "NA" + tab + tab + tab + T_FV_6003_C + tab + T_FV_6003_M);
				fvO.returnRecordType = RecType;
				return;
			}

			//validation starts 
			if (SecVIA_LineNo.equals(FIELD_NULL) || SecVIA_LineNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				SecVIA_LineNo = "-";
			}
			else if (SecVIA_LineNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(SecVIA_LineNo))
				{
					Str_Buffer.append("-" + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
					SecVIA_LineNo = "-";
				}
				else if (Integer.parseInt(SecVIA_LineNo.trim()) != lineCount)
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				}
			}
			else
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Line_Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6005_C + tab + T_FV_6005_M);
				SecVIA_LineNo = "-";
			}
			//	  check Section Chapter VIA LineNo
			//	  check RecType
			if (SecVIA_RecType.equals(FIELD_NULL) || SecVIA_RecType.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Section -Chapter VIA record Type" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6022_C + tab + T_FV_6022_M);
			}
			else if (!(SecVIA_RecType.equals(SECTIONVIA_HEADER_IDENTIFIER)))
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Section -Chapter VIA record Type" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6022_C + tab + T_FV_6022_M);
			}
			//		check SecVIA_SecVIA_RecType

			//	  check BatchNo
			if (SecVIA_BatchNo.equals(FIELD_NULL) || SecVIA_BatchNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
			}
			else if (SecVIA_BatchNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(SecVIA_BatchNo))
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
				}
				else if (Integer.parseInt(BH_BatchNo.trim()) != Integer.parseInt(SecVIA_BatchNo.trim()))
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6029_C + tab + T_FV_6029_M);
				}
			}
			else
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Batch Number" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6007_C + tab + T_FV_6007_M);
			}
			//				check BatchNo
			//		check SecVIA_DeducteeDetailRecNo
			if (SecVIA_DeducteeDetailRecNo.equals(FIELD_NULL) || SecVIA_DeducteeDetailRecNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + "Null" + tab + T_FV_6008_C + tab + T_FV_6008_M);
			    
			}
			else if (SecVIA_DeducteeDetailRecNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(SecVIA_DeducteeDetailRecNo))
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);
					
				}
				else if (Integer.parseInt(SecVIA_DeducteeDetailRecNo.trim()) != Integer.parseInt(DeducteeDetailRecNo.trim()))
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);
					
				}
			}
			else
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6008_C + tab + T_FV_6008_M);
			}
			//	  check SecVIA_DeducteeDetailRecNo

			//	check SECTION 10 DETAIL RECORD
			if (SecVIA_RecordNo.equals(FIELD_NULL) || SecVIA_RecordNo.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail - Chapter VI -A Details Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6012_C + tab + T_FV_6012_M);
			}
			else if (SecVIA_RecordNo.length() <= 9)
			{
				if (obj_FieldValidation.isInt(SecVIA_RecordNo))
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail - Chapter VI -A Details Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6012_C + tab + T_FV_6012_M);
				}
				else if (Integer.parseInt(SecVIA_RecordNo.trim()) != SecVIAValidCount)
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail - Chapter VI -A Details Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6012_C + tab + T_FV_6012_M);
				}
			}
			else
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Salary Detail - Chapter VI -A Details Record No" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6012_C + tab + T_FV_6012_M);
			}
			//	  check DeducteeDetailRecNo

			//	check Section Chapter VI-A I.D.
			boolean errUnique = false;
			boolean validSecVIA = false;
			if (SecVIA_ID.equals(FIELD_NULL) || SecVIA_ID.equals(FIELD_SEPERATOR))
			{
				Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6015_C + tab + T_FV_6015_M);
			}
			else
			{
				if (SecVIA_ID.length() <= 15)
				{
					for (int localX = 0; localX < secVIAIdentification.length; localX++)
					{
						if (SecVIA_ID.equals(secVIAIdentification[localX]))
						{
							validSecVIA = true;
							break;
						}
					}
					if (validSecVIA == false)
					{
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6015_C + tab + T_FV_6015_M);
					}

					if (validSecVIA)
					{
						for (int localI = 0; localI < SecVIAValidCount; localI++)
						{
							if (secVIAArray[localI] != null && secVIAArray[localI].equals(SecVIA_ID))
							{
								errUnique = true;
								Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6027_C + tab + T_FV_6027_M);
								break;
							}
						}

						if (errUnique == false)
						{
							secVIAArray[SecVIAValidCount - 1] = SecVIA_ID;
						}
					}
				}
				else
				{
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6015_C + tab + T_FV_6015_M);
				}
			}
			//END	  check Section Chapter VI-A I.D.
			
			//M01_B
			//Checking the order of Section.  It should be of the order 80CCE,80CCF,OTHERS.
			if(!errUnique) //check for the sequence only if the sections are unique and valid.
			{
				if(SecVIAValidCount==3)
				{

					if(secVIAArray[1]!= null && secVIAArray[1].equals("OTHERS")) //As for (SecVIAValidCount==3), the conditions specified in (SecVIAValidCount==2) are checked, these are not checked explicitly here .  

					if(secVIAArray[1].equals("OTHERS")) //As for (SecVIAValidCount==3), the conditions specified in (SecVIAValidCount==2) are checked, these are not checked explicitly here .  

					{
						
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6043_C + tab + T_FV_6043_M);
					}
				}
				else if (SecVIAValidCount==2)
				{
					if((secVIAArray[0]!= null && secVIAArray[0].equals("80CCF")) && (secVIAArray[1]!= null && secVIAArray[1].equals("80CCE")))
					{
						
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6043_C + tab + T_FV_6043_M);
					}
					else if(secVIAArray[0] != null && secVIAArray[0].equals("OTHERS"))
					{
						
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Chapter VI-A Section ID" + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6043_C + tab + T_FV_6043_M);
					}
				}
			}
			//Ends Checking the order of Section.  It should be of the order 80CCE,80CCF,OTHERS.
			//M01_E
			
			
			//boolean validSecVIATotAmount = false;    //Commented by Dhanya as the variable is declared as a class variable; since it has to be initialized only once for a file. on 03/02/2011 as 4047 msg has to be displayed only if all the amount in 16A are valid.                    
			
			if (SecVIA_TotAmount.equals(FIELD_NULL) || SecVIA_TotAmount.equals(FIELD_SEPERATOR))
			{
				validSecVIATotAmount = false; //Added by Dhanya on 03/02/2011 as 4047 msg has to be displayed only if all the amount in 16A are valid.
				//M01_B
				if(SecVIA_ID.equals("80CCF")) //if invalid incase of 80CCE, show msg specific to 80CCF
				{
					
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Amount " + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6042_C + tab + T_FV_6042_M);
				}
				//M01_E
				else  //for all other cases
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Amount " + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6021_C + tab + T_FV_6021_M);
			}
			else if (SecVIA_TotAmount.length() <= 15)
			{
				
				if (obj_FieldValidation.isDecimalNumber(SecVIA_TotAmount))
				{
					validSecVIATotAmount = false; //Added by Dhanya on 03/02/2011 as 4047 msg has to be displayed only if all the amount in 16A are valid.
				    //M01_B
					if(SecVIA_ID.equals("80CCF")) //if invalid incase of 80CCE, show msg specific to 80CCF
					{
						
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Amount " + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6044_C + tab + T_FV_6044_M);
					}
					//M01_E
					else //for all other sections
					{
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Amount " + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6021_C + tab + T_FV_6021_M);
					}
				}
				else if (SecVIA_ID.equals("80CCE") && Double.parseDouble(SecVIA_TotAmount.trim()) > 100000)
				{
					validSecVIATotAmount = false; //Added by Dhanya on 03/02/2011 as 4047 msg has to be displayed only if all the amount in 16A are valid.
                    /*
                     * Code modified to allow paper ret in which 80CCE amount is greater than 1lakh
                     * warning file will be generated
                     */
					if (paperReturnFile)
					{
                        fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(SecVIA_LineNo + tab + BH_BatchNo + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6039_C + tab + T_FV_6039_M);
					}
					else
					{
						Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Amount " + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6039_C + tab + T_FV_6039_M);
					}
				}
				//M01_B
				else if (SecVIA_ID.equals("80CCF") && Double.parseDouble(SecVIA_TotAmount.trim()) > 20000)
				{
					validSecVIATotAmount = false; //Added by Dhanya on 03/02/2011 as 4047 msg has to be displayed only if all the amount in 16A are valid.
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Amount " + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6040_C + tab + T_FV_6040_M);
				}
				//M01_E
				/*else  commented by Dhanya on 03/02/2011 as 4047 msg has to be displayed only if all the amount in 16A are valid.
				{
					validSecVIATotAmount = true;
				}*/
			}
			else 
			{
				validSecVIATotAmount = false; //Added by Dhanya on 03/02/2011 as 4047 msg has to be displayed only if all the amount in 16A are valid.
			    ////M01_B
				if(SecVIA_ID.equals("80CCF")) //if invalid incase of 80CCE, show msg specific to 80CCF
				{
										
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Amount " + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6042_C + tab + T_FV_6042_M);
				}
				//M01_E
				else
				{
										
					Str_Buffer.append(SecVIA_LineNo + tab + v_upload_Type + tab + "Total Amount " + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_6021_C + tab + T_FV_6021_M);
				}
			}
				// if (validSecVIADeductionAmount && !paperReturnFile)
			if (validSecVIATotAmount)
			{
				
							
				sumSectionVIA = sumSectionVIA + Double.parseDouble(SecVIA_TotAmount.trim());

						
				/*  Code Changed 16 July 05
				 *  d4 = Math.round((double)(d4 * 100)) /100.0;	
				 */
				sumSectionVIA = Math.round((double) (sumSectionVIA * 100)) / 100.0;
				
							
				
				if (SecVIAValidCount == Integer.parseInt(SecVIACount.trim())
					&& (sumSectionVIA * 100 < (-1000.0 + (Double.parseDouble(SecVIATotalAmount.trim()) * 100)) || sumSectionVIA * 100 > (1000.0 + (Double.parseDouble(SecVIATotalAmount.trim()) * 100))))
				{
					
									
					if (paperReturnFile) // && (Double.parseDouble(SecVIATotalAmount.trim()) == 0))
					{
						fvO.setPaperReturnRelax(true);
						Str_Buffer.appendPaperWarning(lineNoOfSalaryDetailRec + tab + BH_BatchNo + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail " + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_4047_C + tab + T_FV_4047_M);
					}
					else
						Str_Buffer.append(lineNoOfSalaryDetailRec + tab + v_upload_Type + tab + "Gross Total of 'Amount deductible under provisions of chapter VI-A' under  associated ' Salary Details  - Chapter VIA Detail " + tab + "NA" + tab + SecVIA_DeducteeDetailRecNo + tab + T_FV_4047_C + tab + T_FV_4047_M);
				}
			}

		}
		catch (Exception e)
		{
				
			throw e;
		}
		fvO.returnRecordType = RecType;
		return;
	}

	public StringBuffer getStatisticFileSDRec()
	{
		return statisticFileSDRec;
	}

}
